/* sudoku-view.c generated by valac 0.56.16, the Vala compiler
 * generated from sudoku-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include "libsudoku.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
enum  {
	SUDOKU_VIEW_0_PROPERTY,
	SUDOKU_VIEW_GAME_PROPERTY,
	SUDOKU_VIEW_SELECTED_ROW_PROPERTY,
	SUDOKU_VIEW_SELECTED_COL_PROPERTY,
	SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHTER_PROPERTY,
	SUDOKU_VIEW_HAS_SELECTION_PROPERTY,
	SUDOKU_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_view_properties[SUDOKU_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block12Data Block12Data;

#define TYPE_SUDOKU_FRAME (sudoku_frame_get_type ())
#define SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_FRAME, SudokuFrame))
#define SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_FRAME, SudokuFrameClass))
#define IS_SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_FRAME))
#define IS_SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_FRAME))
#define SUDOKU_FRAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_FRAME, SudokuFrameClass))

typedef struct _SudokuFrame SudokuFrame;
typedef struct _SudokuFrameClass SudokuFrameClass;
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
typedef struct _Block13Data Block13Data;
enum  {
	SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL,
	SUDOKU_VIEW_NUM_SIGNALS
};
static guint sudoku_view_signals[SUDOKU_VIEW_NUM_SIGNALS] = {0};

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

struct _SudokuViewPrivate {
	SudokuGame* _game;
	SudokuCell** cells;
	gint cells_length1;
	gint cells_length2;
	GtkLabel* paused;
	GtkOverlay* overlay;
	GtkGrid* grid;
	gint _selected_row;
	gint _selected_col;
	gboolean _show_warnings;
	gboolean _show_extra_warnings;
	gboolean _show_possibilities;
	gboolean _highlighter;
	gboolean _has_selection;
};

struct _Block12Data {
	int _ref_count_;
	SudokuView* self;
	SudokuGame* game;
};

struct _Block13Data {
	int _ref_count_;
	Block12Data * _data12_;
	SudokuCell* cell;
	gint cell_row;
	gint cell_col;
};

static gint SudokuView_private_offset;
static gpointer sudoku_view_parent_class = NULL;

VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
static void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
VALA_EXTERN gint sudoku_view_get_selected_row (SudokuView* self);
VALA_EXTERN gint sudoku_view_get_selected_col (SudokuView* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
static void sudoku_view_set_selected_row (SudokuView* self,
                                   gint value);
static void sudoku_view_set_selected_col (SudokuView* self,
                                   gint value);
VALA_EXTERN SudokuView* sudoku_view_new (SudokuGame* game,
                             GSettings* settings);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   SudokuGame* game,
                                   GSettings* settings);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
VALA_EXTERN GType sudoku_frame_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuFrame, g_object_unref)
VALA_EXTERN SudokuFrame* sudoku_frame_new (GtkWidget* child);
VALA_EXTERN SudokuFrame* sudoku_frame_construct (GType object_type,
                                     GtkWidget* child);
static void sudoku_view_set_game (SudokuView* self,
                           SudokuGame* value);
VALA_EXTERN SudokuGame* sudoku_view_get_game (SudokuView* self);
static void __lambda11_ (SudokuView* self);
static void sudoku_view_clear_all_warnings (SudokuView* self);
static void sudoku_view_update_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_has_selection (SudokuView* self,
                                    gboolean value);
static void ___lambda11__sudoku_game_paused_changed (SudokuGame* _sender,
                                              gpointer self);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame** game);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame** game);
static void ________lambda12_ (Block13Data* _data13_);
static void _________lambda12__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
static void ________lambda13_ (SudokuView* self);
VALA_EXTERN void sudoku_view_dismiss_popovers (SudokuView* self);
static void _________lambda13__sudoku_cell_will_open_popover (SudokuCell* _sender,
                                                       gpointer self);
VALA_EXTERN void sudoku_cell_initialize_earmarks (SudokuCell* self,
                                      gboolean show_possibilities,
                                      gboolean force);
VALA_EXTERN gboolean sudoku_view_get_show_possibilities (SudokuView* self);
static void sudoku_view_cell_changed_cb (SudokuView* self,
                                  gint row,
                                  gint col,
                                  gint old_val,
                                  gint new_val);
static void _sudoku_view_cell_changed_cb_sudoku_board_cell_changed (SudokuBoard* _sender,
                                                             gint row,
                                                             gint col,
                                                             gint old_val,
                                                             gint new_val,
                                                             gpointer self);
static void sudoku_view_earmark_changed_cb (SudokuView* self,
                                     gint row,
                                     gint col,
                                     gint num,
                                     gboolean enabled);
static void _sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed (SudokuBoard* _sender,
                                                                   gint row,
                                                                   gint col,
                                                                   gint num,
                                                                   gboolean enabled,
                                                                   gpointer self);
static void sudoku_view_selection_changed_cb (SudokuView* self,
                                       gint old_row,
                                       gint old_col,
                                       gint new_row,
                                       gint new_col);
static void _sudoku_view_selection_changed_cb_sudoku_view_selection_changed (SudokuView* _sender,
                                                                      gint old_row,
                                                                      gint old_col,
                                                                      gint new_row,
                                                                      gint new_col,
                                                                      gpointer self);
static void sudoku_view_set_cell_highlighter (SudokuView* self,
                                       gint row,
                                       gint col,
                                       gboolean enabled);
VALA_EXTERN void sudoku_cell_dismiss_popover (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_value (SudokuCell* self);
static void sudoku_view_set_value_highlighter (SudokuView* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN void sudoku_cell_update_earmark (SudokuCell* self,
                                 gint num);
VALA_EXTERN void sudoku_cell_check_earmark_warnings (SudokuCell* self,
                                         gint num);
VALA_EXTERN gboolean sudoku_view_get_highlighter (SudokuView* self);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_value (SudokuCell* self,
                                        gboolean value);
VALA_EXTERN void sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_background (SudokuCell* self,
                                             gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_warnings (SudokuView* self);
VALA_EXTERN void sudoku_cell_check_value_warnings (SudokuCell* self,
                                       gboolean show_extra_warnings);
VALA_EXTERN gboolean sudoku_view_get_show_extra_warnings (SudokuView* self);
VALA_EXTERN void sudoku_cell_check_earmarks_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_view_clear (SudokuView* self);
VALA_EXTERN void sudoku_cell_clear_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_view_set_show_warnings (SudokuView* self,
                                    gboolean value);
VALA_EXTERN void sudoku_view_set_show_extra_warnings (SudokuView* self,
                                          gboolean value);
VALA_EXTERN void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
VALA_EXTERN void sudoku_view_set_highlighter (SudokuView* self,
                                  gboolean value);
VALA_EXTERN gboolean sudoku_view_get_has_selection (SudokuView* self);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static gboolean _sudoku_view___lambda14_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda14__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda15_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda15__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda16_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda16__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda17_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda17__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static void sudoku_view_finalize (GObject * obj);
static GType sudoku_view_get_type_once (void);
static void _vala_sudoku_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_view_get_instance_private (SudokuView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuView_private_offset);
}

static void
sudoku_view_set_selected (SudokuView* self,
                          gint cell_row,
                          gint cell_col)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_;
	gint old_row = 0;
	gint _tmp10_;
	gint old_col = 0;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gboolean _tmp14_ = FALSE;
	gint _tmp15_;
#line 45 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->_selected_row;
#line 47 "../src/sudoku-view.vala"
	if (_tmp1_ == cell_row) {
#line 348 "sudoku-view.c"
		gint _tmp2_;
#line 47 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->_selected_col;
#line 47 "../src/sudoku-view.vala"
		_tmp0_ = _tmp2_ == cell_col;
#line 354 "sudoku-view.c"
	} else {
#line 47 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 358 "sudoku-view.c"
	}
#line 47 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 48 "../src/sudoku-view.vala"
		return;
#line 364 "sudoku-view.c"
	}
#line 50 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->_selected_row;
#line 50 "../src/sudoku-view.vala"
	if (_tmp4_ >= 0) {
#line 370 "sudoku-view.c"
		gint _tmp5_;
#line 50 "../src/sudoku-view.vala"
		_tmp5_ = self->priv->_selected_col;
#line 50 "../src/sudoku-view.vala"
		_tmp3_ = _tmp5_ >= 0;
#line 376 "sudoku-view.c"
	} else {
#line 50 "../src/sudoku-view.vala"
		_tmp3_ = FALSE;
#line 380 "sudoku-view.c"
	}
#line 50 "../src/sudoku-view.vala"
	if (_tmp3_) {
#line 384 "sudoku-view.c"
		SudokuCell** _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		gint _tmp7_;
		gint _tmp8_;
		SudokuCell* _tmp9_;
#line 51 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->cells;
#line 51 "../src/sudoku-view.vala"
		_tmp6__length1 = self->priv->cells_length1;
#line 51 "../src/sudoku-view.vala"
		_tmp6__length2 = self->priv->cells_length2;
#line 51 "../src/sudoku-view.vala"
		_tmp7_ = self->priv->_selected_row;
#line 51 "../src/sudoku-view.vala"
		_tmp8_ = self->priv->_selected_col;
#line 51 "../src/sudoku-view.vala"
		_tmp9_ = _tmp6_[(_tmp7_ * _tmp6__length2) + _tmp8_];
#line 51 "../src/sudoku-view.vala"
		sudoku_cell_set_selected (_tmp9_, FALSE);
#line 405 "sudoku-view.c"
	}
#line 53 "../src/sudoku-view.vala"
	_tmp10_ = self->priv->_selected_row;
#line 53 "../src/sudoku-view.vala"
	old_row = _tmp10_;
#line 54 "../src/sudoku-view.vala"
	_tmp11_ = self->priv->_selected_col;
#line 54 "../src/sudoku-view.vala"
	old_col = _tmp11_;
#line 56 "../src/sudoku-view.vala"
	sudoku_view_set_selected_row (self, cell_row);
#line 57 "../src/sudoku-view.vala"
	sudoku_view_set_selected_col (self, cell_col);
#line 59 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->_selected_row;
#line 59 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->_selected_col;
#line 59 "../src/sudoku-view.vala"
	g_signal_emit (self, sudoku_view_signals[SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL], 0, old_row, old_col, _tmp12_, _tmp13_);
#line 61 "../src/sudoku-view.vala"
	_tmp15_ = self->priv->_selected_row;
#line 61 "../src/sudoku-view.vala"
	if (_tmp15_ >= 0) {
#line 429 "sudoku-view.c"
		gint _tmp16_;
#line 61 "../src/sudoku-view.vala"
		_tmp16_ = self->priv->_selected_col;
#line 61 "../src/sudoku-view.vala"
		_tmp14_ = _tmp16_ >= 0;
#line 435 "sudoku-view.c"
	} else {
#line 61 "../src/sudoku-view.vala"
		_tmp14_ = FALSE;
#line 439 "sudoku-view.c"
	}
#line 61 "../src/sudoku-view.vala"
	if (_tmp14_) {
#line 443 "sudoku-view.c"
		SudokuCell** _tmp17_;
		gint _tmp17__length1;
		gint _tmp17__length2;
		gint _tmp18_;
		gint _tmp19_;
		SudokuCell* _tmp20_;
#line 62 "../src/sudoku-view.vala"
		_tmp17_ = self->priv->cells;
#line 62 "../src/sudoku-view.vala"
		_tmp17__length1 = self->priv->cells_length1;
#line 62 "../src/sudoku-view.vala"
		_tmp17__length2 = self->priv->cells_length2;
#line 62 "../src/sudoku-view.vala"
		_tmp18_ = self->priv->_selected_row;
#line 62 "../src/sudoku-view.vala"
		_tmp19_ = self->priv->_selected_col;
#line 62 "../src/sudoku-view.vala"
		_tmp20_ = _tmp17_[(_tmp18_ * _tmp17__length2) + _tmp19_];
#line 62 "../src/sudoku-view.vala"
		sudoku_cell_set_selected (_tmp20_, TRUE);
#line 464 "sudoku-view.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 65 "../src/sudoku-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 473 "sudoku-view.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 65 "../src/sudoku-view.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 65 "../src/sudoku-view.vala"
	return _data12_;
#line 483 "sudoku-view.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 65 "../src/sudoku-view.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 493 "sudoku-view.c"
		SudokuView* self;
#line 65 "../src/sudoku-view.vala"
		self = _data12_->self;
#line 65 "../src/sudoku-view.vala"
		_g_object_unref0 (_data12_->game);
#line 65 "../src/sudoku-view.vala"
		_g_object_unref0 (self);
#line 65 "../src/sudoku-view.vala"
		g_slice_free (Block12Data, _data12_);
#line 503 "sudoku-view.c"
	}
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 93 "../src/sudoku-view.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 512 "sudoku-view.c"
}

static void
__lambda11_ (SudokuView* self)
{
	PangoAttrList* attr_list = NULL;
	GtkLabel* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp3_;
	PangoAttrList* _tmp5_;
	PangoAttribute* _tmp6_;
	GtkLabel* _tmp7_;
	PangoAttrList* _tmp8_;
	GtkLabel* _tmp9_;
	SudokuGame* _tmp10_;
	SudokuGame* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	SudokuGame* _tmp14_;
	SudokuGame* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	SudokuGame* _tmp18_;
	SudokuGame* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
#line 93 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->paused;
#line 93 "../src/sudoku-view.vala"
	_tmp1_ = gtk_label_get_attributes (_tmp0_);
#line 93 "../src/sudoku-view.vala"
	_tmp2_ = _pango_attr_list_ref0 (_tmp1_);
#line 93 "../src/sudoku-view.vala"
	attr_list = _tmp2_;
#line 94 "../src/sudoku-view.vala"
	_tmp3_ = attr_list;
#line 94 "../src/sudoku-view.vala"
	if (_tmp3_ == NULL) {
#line 552 "sudoku-view.c"
		PangoAttrList* _tmp4_;
#line 95 "../src/sudoku-view.vala"
		_tmp4_ = pango_attr_list_new ();
#line 95 "../src/sudoku-view.vala"
		_pango_attr_list_unref0 (attr_list);
#line 95 "../src/sudoku-view.vala"
		attr_list = _tmp4_;
#line 560 "sudoku-view.c"
	}
#line 97 "../src/sudoku-view.vala"
	_tmp5_ = attr_list;
#line 97 "../src/sudoku-view.vala"
	_tmp6_ = pango_attr_size_new_absolute (((gint) (gtk_widget_get_width ((GtkWidget*) self) * 0.125)) * PANGO_SCALE);
#line 97 "../src/sudoku-view.vala"
	pango_attr_list_change (_tmp5_, _tmp6_);
#line 101 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->paused;
#line 101 "../src/sudoku-view.vala"
	_tmp8_ = attr_list;
#line 101 "../src/sudoku-view.vala"
	gtk_label_set_attributes (_tmp7_, _tmp8_);
#line 102 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->paused;
#line 102 "../src/sudoku-view.vala"
	_tmp10_ = sudoku_view_get_game (self);
#line 102 "../src/sudoku-view.vala"
	_tmp11_ = _tmp10_;
#line 102 "../src/sudoku-view.vala"
	_tmp12_ = sudoku_game_get_paused (_tmp11_);
#line 102 "../src/sudoku-view.vala"
	_tmp13_ = _tmp12_;
#line 102 "../src/sudoku-view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, _tmp13_);
#line 104 "../src/sudoku-view.vala"
	_tmp14_ = sudoku_view_get_game (self);
#line 104 "../src/sudoku-view.vala"
	_tmp15_ = _tmp14_;
#line 104 "../src/sudoku-view.vala"
	_tmp16_ = sudoku_game_get_paused (_tmp15_);
#line 104 "../src/sudoku-view.vala"
	_tmp17_ = _tmp16_;
#line 104 "../src/sudoku-view.vala"
	if (_tmp17_) {
#line 105 "../src/sudoku-view.vala"
		sudoku_view_clear_all_warnings (self);
#line 598 "sudoku-view.c"
	} else {
#line 107 "../src/sudoku-view.vala"
		sudoku_view_update_warnings (self);
#line 602 "sudoku-view.c"
	}
#line 109 "../src/sudoku-view.vala"
	_tmp18_ = sudoku_view_get_game (self);
#line 109 "../src/sudoku-view.vala"
	_tmp19_ = _tmp18_;
#line 109 "../src/sudoku-view.vala"
	_tmp20_ = sudoku_game_get_paused (_tmp19_);
#line 109 "../src/sudoku-view.vala"
	_tmp21_ = _tmp20_;
#line 109 "../src/sudoku-view.vala"
	sudoku_view_set_has_selection (self, !_tmp21_);
#line 91 "../src/sudoku-view.vala"
	_pango_attr_list_unref0 (attr_list);
#line 616 "sudoku-view.c"
}

static void
___lambda11__sudoku_game_paused_changed (SudokuGame* _sender,
                                         gpointer self)
{
#line 91 "../src/sudoku-view.vala"
	__lambda11_ ((SudokuView*) self);
#line 625 "sudoku-view.c"
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
#line 142 "../src/sudoku-view.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 142 "../src/sudoku-view.vala"
	return _data13_;
#line 635 "sudoku-view.c"
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 142 "../src/sudoku-view.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 645 "sudoku-view.c"
		SudokuView* self;
#line 142 "../src/sudoku-view.vala"
		self = _data13_->_data12_->self;
#line 142 "../src/sudoku-view.vala"
		_g_object_unref0 (_data13_->cell);
#line 142 "../src/sudoku-view.vala"
		block12_data_unref (_data13_->_data12_);
#line 142 "../src/sudoku-view.vala"
		_data13_->_data12_ = NULL;
#line 142 "../src/sudoku-view.vala"
		g_slice_free (Block13Data, _data13_);
#line 657 "sudoku-view.c"
	}
}

static void
________lambda12_ (Block13Data* _data13_)
{
	Block12Data* _data12_;
	SudokuView* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuCell* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 148 "../src/sudoku-view.vala"
	_data12_ = _data13_->_data12_;
#line 148 "../src/sudoku-view.vala"
	self = _data12_->self;
#line 149 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_game_get_paused (_data12_->game);
#line 149 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 149 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 150 "../src/sudoku-view.vala"
		return;
#line 683 "sudoku-view.c"
	}
#line 152 "../src/sudoku-view.vala"
	_tmp2_ = _data13_->cell;
#line 152 "../src/sudoku-view.vala"
	g_object_get ((GtkWidget*) _tmp2_, "has-focus", &_tmp3_, NULL);
#line 152 "../src/sudoku-view.vala"
	_tmp4_ = _tmp3_;
#line 152 "../src/sudoku-view.vala"
	if (_tmp4_) {
#line 153 "../src/sudoku-view.vala"
		sudoku_view_set_selected (self, _data13_->cell_row, _data13_->cell_col);
#line 695 "sudoku-view.c"
	}
}

static void
_________lambda12__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
#line 148 "../src/sudoku-view.vala"
	________lambda12_ (self);
#line 706 "sudoku-view.c"
}

static void
________lambda13_ (SudokuView* self)
{
#line 157 "../src/sudoku-view.vala"
	sudoku_view_dismiss_popovers (self);
#line 714 "sudoku-view.c"
}

static void
_________lambda13__sudoku_cell_will_open_popover (SudokuCell* _sender,
                                                  gpointer self)
{
#line 156 "../src/sudoku-view.vala"
	________lambda13_ ((SudokuView*) self);
#line 723 "sudoku-view.c"
}

static void
_sudoku_view_cell_changed_cb_sudoku_board_cell_changed (SudokuBoard* _sender,
                                                        gint row,
                                                        gint col,
                                                        gint old_val,
                                                        gint new_val,
                                                        gpointer self)
{
#line 167 "../src/sudoku-view.vala"
	sudoku_view_cell_changed_cb ((SudokuView*) self, row, col, old_val, new_val);
#line 736 "sudoku-view.c"
}

static void
_sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed (SudokuBoard* _sender,
                                                              gint row,
                                                              gint col,
                                                              gint num,
                                                              gboolean enabled,
                                                              gpointer self)
{
#line 168 "../src/sudoku-view.vala"
	sudoku_view_earmark_changed_cb ((SudokuView*) self, row, col, num, enabled);
#line 749 "sudoku-view.c"
}

static void
_sudoku_view_selection_changed_cb_sudoku_view_selection_changed (SudokuView* _sender,
                                                                 gint old_row,
                                                                 gint old_col,
                                                                 gint new_row,
                                                                 gint new_col,
                                                                 gpointer self)
{
#line 169 "../src/sudoku-view.vala"
	sudoku_view_selection_changed_cb ((SudokuView*) self, old_row, old_col, new_row, new_col);
#line 762 "sudoku-view.c"
}

SudokuView*
sudoku_view_construct (GType object_type,
                       SudokuGame* game,
                       GSettings* settings)
{
	SudokuView * self = NULL;
	Block12Data* _data12_;
	SudokuGame* _tmp0_;
	GameMode _tmp1_;
	GameMode _tmp2_;
	GtkOverlay* _tmp3_;
	SudokuFrame* frame = NULL;
	GtkOverlay* _tmp4_;
	SudokuFrame* _tmp5_;
	SudokuFrame* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkGrid* _tmp9_;
	SudokuGame* _tmp11_;
	SudokuGame* _tmp12_;
	GtkGrid* _tmp13_ = NULL;
	GtkGrid* _tmp14_;
	GtkGrid** blocks = NULL;
	SudokuBoard* _tmp15_;
	SudokuBoard* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	SudokuBoard* _tmp19_;
	SudokuBoard* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	GtkGrid** _tmp23_;
	gint blocks_length1;
	gint blocks_length2;
	SudokuBoard* _tmp47_;
	SudokuBoard* _tmp48_;
	gint _tmp49_;
	gint _tmp50_;
	SudokuBoard* _tmp51_;
	SudokuBoard* _tmp52_;
	gint _tmp53_;
	gint _tmp54_;
	SudokuCell** _tmp55_;
	SudokuGame* _tmp97_;
	SudokuGame* _tmp98_;
	SudokuBoard* _tmp99_;
	SudokuBoard* _tmp100_;
	SudokuGame* _tmp101_;
	SudokuGame* _tmp102_;
	SudokuBoard* _tmp103_;
	SudokuBoard* _tmp104_;
	GtkOverlay* _tmp105_;
	GtkLabel* _tmp106_;
	GtkOverlay* _tmp107_;
	GtkGrid* _tmp108_;
	GtkGrid* _tmp109_;
	GtkOverlay* _tmp110_;
	GtkLabel* _tmp111_;
#line 65 "../src/sudoku-view.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 65 "../src/sudoku-view.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 65 "../src/sudoku-view.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 65 "../src/sudoku-view.vala"
	_data12_->_ref_count_ = 1;
#line 65 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 65 "../src/sudoku-view.vala"
	_g_object_unref0 (_data12_->game);
#line 65 "../src/sudoku-view.vala"
	_data12_->game = _tmp0_;
#line 65 "../src/sudoku-view.vala"
	self = (SudokuView*) g_object_new (object_type, NULL);
#line 65 "../src/sudoku-view.vala"
	_data12_->self = g_object_ref (self);
#line 67 "../src/sudoku-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 69 "../src/sudoku-view.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 70 "../src/sudoku-view.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 72 "../src/sudoku-view.vala"
	_tmp1_ = sudoku_game_get_mode (_data12_->game);
#line 72 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 72 "../src/sudoku-view.vala"
	if (_tmp2_ == GAME_MODE_CREATE) {
#line 73 "../src/sudoku-view.vala"
		self->priv->_show_warnings = TRUE;
#line 855 "sudoku-view.c"
	} else {
#line 75 "../src/sudoku-view.vala"
		self->priv->_show_warnings = g_settings_get_boolean (settings, "show-warnings");
#line 859 "sudoku-view.c"
	}
#line 76 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = g_settings_get_boolean (settings, "show-possibilities");
#line 77 "../src/sudoku-view.vala"
	self->priv->_show_extra_warnings = g_settings_get_boolean (settings, "show-extra-warnings");
#line 78 "../src/sudoku-view.vala"
	self->priv->_highlighter = g_settings_get_boolean (settings, "highlighter");
#line 80 "../src/sudoku-view.vala"
	_tmp3_ = (GtkOverlay*) gtk_overlay_new ();
#line 80 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp3_);
#line 80 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->overlay);
#line 80 "../src/sudoku-view.vala"
	self->priv->overlay = _tmp3_;
#line 81 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->overlay;
#line 81 "../src/sudoku-view.vala"
	_tmp5_ = sudoku_frame_new ((GtkWidget*) _tmp4_);
#line 81 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp5_);
#line 81 "../src/sudoku-view.vala"
	frame = _tmp5_;
#line 82 "../src/sudoku-view.vala"
	_tmp6_ = frame;
#line 82 "../src/sudoku-view.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp6_);
#line 84 "../src/sudoku-view.vala"
	_tmp7_ = (GtkLabel*) gtk_label_new ("Paused");
#line 84 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp7_);
#line 84 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->paused);
#line 84 "../src/sudoku-view.vala"
	self->priv->paused = _tmp7_;
#line 85 "../src/sudoku-view.vala"
	_tmp8_ = self->priv->paused;
#line 85 "../src/sudoku-view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "paused");
#line 87 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->grid;
#line 87 "../src/sudoku-view.vala"
	if (_tmp9_ != NULL) {
#line 903 "sudoku-view.c"
		GtkOverlay* _tmp10_;
#line 88 "../src/sudoku-view.vala"
		_tmp10_ = self->priv->overlay;
#line 88 "../src/sudoku-view.vala"
		gtk_overlay_set_child (_tmp10_, NULL);
#line 909 "sudoku-view.c"
	}
#line 90 "../src/sudoku-view.vala"
	sudoku_view_set_game (self, _data12_->game);
#line 91 "../src/sudoku-view.vala"
	_tmp11_ = sudoku_view_get_game (self);
#line 91 "../src/sudoku-view.vala"
	_tmp12_ = _tmp11_;
#line 91 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp12_, "paused-changed", (GCallback) ___lambda11__sudoku_game_paused_changed, self, 0);
#line 112 "../src/sudoku-view.vala"
	_tmp13_ = (GtkGrid*) gtk_grid_new ();
#line 112 "../src/sudoku-view.vala"
	gtk_grid_set_row_spacing (_tmp13_, 2);
#line 112 "../src/sudoku-view.vala"
	gtk_grid_set_column_spacing (_tmp13_, 2);
#line 112 "../src/sudoku-view.vala"
	gtk_grid_set_column_homogeneous (_tmp13_, TRUE);
#line 112 "../src/sudoku-view.vala"
	gtk_grid_set_row_homogeneous (_tmp13_, TRUE);
#line 112 "../src/sudoku-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp13_, TRUE);
#line 112 "../src/sudoku-view.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp13_, TRUE);
#line 112 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp13_);
#line 112 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->grid);
#line 112 "../src/sudoku-view.vala"
	self->priv->grid = _tmp13_;
#line 120 "../src/sudoku-view.vala"
	_tmp14_ = self->priv->grid;
#line 120 "../src/sudoku-view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp14_, "board");
#line 122 "../src/sudoku-view.vala"
	_tmp15_ = sudoku_game_get_board (_data12_->game);
#line 122 "../src/sudoku-view.vala"
	_tmp16_ = _tmp15_;
#line 122 "../src/sudoku-view.vala"
	_tmp17_ = sudoku_board_get_block_rows (_tmp16_);
#line 122 "../src/sudoku-view.vala"
	_tmp18_ = _tmp17_;
#line 122 "../src/sudoku-view.vala"
	_tmp19_ = sudoku_game_get_board (_data12_->game);
#line 122 "../src/sudoku-view.vala"
	_tmp20_ = _tmp19_;
#line 122 "../src/sudoku-view.vala"
	_tmp21_ = sudoku_board_get_block_cols (_tmp20_);
#line 122 "../src/sudoku-view.vala"
	_tmp22_ = _tmp21_;
#line 122 "../src/sudoku-view.vala"
	_tmp23_ = g_new0 (GtkGrid*, (_tmp18_ * _tmp22_) + 1);
#line 122 "../src/sudoku-view.vala"
	blocks = _tmp23_;
#line 122 "../src/sudoku-view.vala"
	blocks_length1 = _tmp18_;
#line 122 "../src/sudoku-view.vala"
	blocks_length2 = _tmp22_;
#line 967 "sudoku-view.c"
	{
		gint block_row = 0;
#line 123 "../src/sudoku-view.vala"
		block_row = 0;
#line 972 "sudoku-view.c"
		{
			gboolean _tmp24_ = FALSE;
#line 123 "../src/sudoku-view.vala"
			_tmp24_ = TRUE;
#line 123 "../src/sudoku-view.vala"
			while (TRUE) {
#line 979 "sudoku-view.c"
				SudokuBoard* _tmp26_;
				SudokuBoard* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
#line 123 "../src/sudoku-view.vala"
				if (!_tmp24_) {
#line 986 "sudoku-view.c"
					gint _tmp25_;
#line 123 "../src/sudoku-view.vala"
					_tmp25_ = block_row;
#line 123 "../src/sudoku-view.vala"
					block_row = _tmp25_ + 1;
#line 992 "sudoku-view.c"
				}
#line 123 "../src/sudoku-view.vala"
				_tmp24_ = FALSE;
#line 123 "../src/sudoku-view.vala"
				_tmp26_ = sudoku_game_get_board (_data12_->game);
#line 123 "../src/sudoku-view.vala"
				_tmp27_ = _tmp26_;
#line 123 "../src/sudoku-view.vala"
				_tmp28_ = sudoku_board_get_block_rows (_tmp27_);
#line 123 "../src/sudoku-view.vala"
				_tmp29_ = _tmp28_;
#line 123 "../src/sudoku-view.vala"
				if (!(block_row < _tmp29_)) {
#line 123 "../src/sudoku-view.vala"
					break;
#line 1008 "sudoku-view.c"
				}
				{
					gint block_col = 0;
#line 125 "../src/sudoku-view.vala"
					block_col = 0;
#line 1014 "sudoku-view.c"
					{
						gboolean _tmp30_ = FALSE;
#line 125 "../src/sudoku-view.vala"
						_tmp30_ = TRUE;
#line 125 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1021 "sudoku-view.c"
							SudokuBoard* _tmp32_;
							SudokuBoard* _tmp33_;
							gint _tmp34_;
							gint _tmp35_;
							GtkGrid* block_grid = NULL;
							GtkGrid* _tmp36_;
							GtkGrid* _tmp37_;
							GtkGrid* _tmp38_;
							GtkGrid* _tmp39_;
							GtkGrid* _tmp40_;
							GtkGrid* _tmp41_;
							GtkGrid* _tmp42_;
							GtkGrid* _tmp43_;
							GtkGrid** _tmp44_;
							gint _tmp44__length1;
							gint _tmp44__length2;
							GtkGrid* _tmp45_;
							GtkGrid* _tmp46_;
#line 125 "../src/sudoku-view.vala"
							if (!_tmp30_) {
#line 1042 "sudoku-view.c"
								gint _tmp31_;
#line 125 "../src/sudoku-view.vala"
								_tmp31_ = block_col;
#line 125 "../src/sudoku-view.vala"
								block_col = _tmp31_ + 1;
#line 1048 "sudoku-view.c"
							}
#line 125 "../src/sudoku-view.vala"
							_tmp30_ = FALSE;
#line 125 "../src/sudoku-view.vala"
							_tmp32_ = sudoku_game_get_board (_data12_->game);
#line 125 "../src/sudoku-view.vala"
							_tmp33_ = _tmp32_;
#line 125 "../src/sudoku-view.vala"
							_tmp34_ = sudoku_board_get_block_cols (_tmp33_);
#line 125 "../src/sudoku-view.vala"
							_tmp35_ = _tmp34_;
#line 125 "../src/sudoku-view.vala"
							if (!(block_col < _tmp35_)) {
#line 125 "../src/sudoku-view.vala"
								break;
#line 1064 "sudoku-view.c"
							}
#line 127 "../src/sudoku-view.vala"
							_tmp36_ = (GtkGrid*) gtk_grid_new ();
#line 127 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp36_);
#line 127 "../src/sudoku-view.vala"
							block_grid = _tmp36_;
#line 128 "../src/sudoku-view.vala"
							_tmp37_ = block_grid;
#line 128 "../src/sudoku-view.vala"
							gtk_grid_set_row_spacing (_tmp37_, 1);
#line 129 "../src/sudoku-view.vala"
							_tmp38_ = block_grid;
#line 129 "../src/sudoku-view.vala"
							gtk_grid_set_column_spacing (_tmp38_, 1);
#line 130 "../src/sudoku-view.vala"
							_tmp39_ = block_grid;
#line 130 "../src/sudoku-view.vala"
							gtk_grid_set_column_homogeneous (_tmp39_, TRUE);
#line 131 "../src/sudoku-view.vala"
							_tmp40_ = block_grid;
#line 131 "../src/sudoku-view.vala"
							gtk_grid_set_row_homogeneous (_tmp40_, TRUE);
#line 132 "../src/sudoku-view.vala"
							_tmp41_ = block_grid;
#line 132 "../src/sudoku-view.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp41_, "block");
#line 133 "../src/sudoku-view.vala"
							_tmp42_ = self->priv->grid;
#line 133 "../src/sudoku-view.vala"
							_tmp43_ = block_grid;
#line 133 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp42_, (GtkWidget*) _tmp43_, block_col, block_row, 1, 1);
#line 135 "../src/sudoku-view.vala"
							_tmp44_ = blocks;
#line 135 "../src/sudoku-view.vala"
							_tmp44__length1 = blocks_length1;
#line 135 "../src/sudoku-view.vala"
							_tmp44__length2 = blocks_length2;
#line 135 "../src/sudoku-view.vala"
							_tmp45_ = block_grid;
#line 135 "../src/sudoku-view.vala"
							_tmp46_ = _g_object_ref0 (_tmp45_);
#line 135 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp44_[(block_row * _tmp44__length2) + block_col]);
#line 135 "../src/sudoku-view.vala"
							_tmp44_[(block_row * _tmp44__length2) + block_col] = _tmp46_;
#line 125 "../src/sudoku-view.vala"
							_g_object_unref0 (block_grid);
#line 1114 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 139 "../src/sudoku-view.vala"
	_tmp47_ = sudoku_game_get_board (_data12_->game);
#line 139 "../src/sudoku-view.vala"
	_tmp48_ = _tmp47_;
#line 139 "../src/sudoku-view.vala"
	_tmp49_ = sudoku_board_get_rows (_tmp48_);
#line 139 "../src/sudoku-view.vala"
	_tmp50_ = _tmp49_;
#line 139 "../src/sudoku-view.vala"
	_tmp51_ = sudoku_game_get_board (_data12_->game);
#line 139 "../src/sudoku-view.vala"
	_tmp52_ = _tmp51_;
#line 139 "../src/sudoku-view.vala"
	_tmp53_ = sudoku_board_get_cols (_tmp52_);
#line 139 "../src/sudoku-view.vala"
	_tmp54_ = _tmp53_;
#line 139 "../src/sudoku-view.vala"
	_tmp55_ = g_new0 (SudokuCell*, (_tmp50_ * _tmp54_) + 1);
#line 139 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 139 "../src/sudoku-view.vala"
	self->priv->cells = _tmp55_;
#line 139 "../src/sudoku-view.vala"
	self->priv->cells_length1 = _tmp50_;
#line 139 "../src/sudoku-view.vala"
	self->priv->cells_length2 = _tmp54_;
#line 1147 "sudoku-view.c"
	{
		gint row = 0;
#line 140 "../src/sudoku-view.vala"
		row = 0;
#line 1152 "sudoku-view.c"
		{
			gboolean _tmp56_ = FALSE;
#line 140 "../src/sudoku-view.vala"
			_tmp56_ = TRUE;
#line 140 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1159 "sudoku-view.c"
				SudokuBoard* _tmp58_;
				SudokuBoard* _tmp59_;
				gint _tmp60_;
				gint _tmp61_;
#line 140 "../src/sudoku-view.vala"
				if (!_tmp56_) {
#line 1166 "sudoku-view.c"
					gint _tmp57_;
#line 140 "../src/sudoku-view.vala"
					_tmp57_ = row;
#line 140 "../src/sudoku-view.vala"
					row = _tmp57_ + 1;
#line 1172 "sudoku-view.c"
				}
#line 140 "../src/sudoku-view.vala"
				_tmp56_ = FALSE;
#line 140 "../src/sudoku-view.vala"
				_tmp58_ = sudoku_game_get_board (_data12_->game);
#line 140 "../src/sudoku-view.vala"
				_tmp59_ = _tmp58_;
#line 140 "../src/sudoku-view.vala"
				_tmp60_ = sudoku_board_get_rows (_tmp59_);
#line 140 "../src/sudoku-view.vala"
				_tmp61_ = _tmp60_;
#line 140 "../src/sudoku-view.vala"
				if (!(row < _tmp61_)) {
#line 140 "../src/sudoku-view.vala"
					break;
#line 1188 "sudoku-view.c"
				}
				{
					gint col = 0;
#line 142 "../src/sudoku-view.vala"
					col = 0;
#line 1194 "sudoku-view.c"
					{
						gboolean _tmp62_ = FALSE;
#line 142 "../src/sudoku-view.vala"
						_tmp62_ = TRUE;
#line 142 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1201 "sudoku-view.c"
							Block13Data* _data13_;
							SudokuBoard* _tmp64_;
							SudokuBoard* _tmp65_;
							gint _tmp66_;
							gint _tmp67_;
							SudokuCell* _tmp68_;
							SudokuCell* _tmp69_;
							SudokuCell* _tmp70_;
							SudokuCell** _tmp71_;
							gint _tmp71__length1;
							gint _tmp71__length2;
							SudokuCell* _tmp72_;
							SudokuCell* _tmp73_;
							SudokuCell** _tmp74_;
							gint _tmp74__length1;
							gint _tmp74__length2;
							SudokuCell* _tmp75_;
							gboolean _tmp76_;
							gboolean _tmp77_;
							GtkGrid** _tmp78_;
							gint _tmp78__length1;
							gint _tmp78__length2;
							SudokuBoard* _tmp79_;
							SudokuBoard* _tmp80_;
							gint _tmp81_;
							gint _tmp82_;
							SudokuBoard* _tmp83_;
							SudokuBoard* _tmp84_;
							gint _tmp85_;
							gint _tmp86_;
							GtkGrid* _tmp87_;
							SudokuCell* _tmp88_;
							SudokuBoard* _tmp89_;
							SudokuBoard* _tmp90_;
							gint _tmp91_;
							gint _tmp92_;
							SudokuBoard* _tmp93_;
							SudokuBoard* _tmp94_;
							gint _tmp95_;
							gint _tmp96_;
#line 142 "../src/sudoku-view.vala"
							_data13_ = g_slice_new0 (Block13Data);
#line 142 "../src/sudoku-view.vala"
							_data13_->_ref_count_ = 1;
#line 142 "../src/sudoku-view.vala"
							_data13_->_data12_ = block12_data_ref (_data12_);
#line 142 "../src/sudoku-view.vala"
							if (!_tmp62_) {
#line 1250 "sudoku-view.c"
								gint _tmp63_;
#line 142 "../src/sudoku-view.vala"
								_tmp63_ = col;
#line 142 "../src/sudoku-view.vala"
								col = _tmp63_ + 1;
#line 1256 "sudoku-view.c"
							}
#line 142 "../src/sudoku-view.vala"
							_tmp62_ = FALSE;
#line 142 "../src/sudoku-view.vala"
							_tmp64_ = sudoku_game_get_board (_data12_->game);
#line 142 "../src/sudoku-view.vala"
							_tmp65_ = _tmp64_;
#line 142 "../src/sudoku-view.vala"
							_tmp66_ = sudoku_board_get_cols (_tmp65_);
#line 142 "../src/sudoku-view.vala"
							_tmp67_ = _tmp66_;
#line 142 "../src/sudoku-view.vala"
							if (!(col < _tmp67_)) {
#line 142 "../src/sudoku-view.vala"
								block13_data_unref (_data13_);
#line 142 "../src/sudoku-view.vala"
								_data13_ = NULL;
#line 142 "../src/sudoku-view.vala"
								break;
#line 1276 "sudoku-view.c"
							}
#line 144 "../src/sudoku-view.vala"
							_tmp68_ = sudoku_cell_new (row, col, &self->priv->_game);
#line 144 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp68_);
#line 144 "../src/sudoku-view.vala"
							_data13_->cell = _tmp68_;
#line 145 "../src/sudoku-view.vala"
							_data13_->cell_row = row;
#line 146 "../src/sudoku-view.vala"
							_data13_->cell_col = col;
#line 148 "../src/sudoku-view.vala"
							_tmp69_ = _data13_->cell;
#line 148 "../src/sudoku-view.vala"
							g_signal_connect_data ((GObject*) _tmp69_, "notify::has-focus", (GCallback) _________lambda12__g_object_notify, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 156 "../src/sudoku-view.vala"
							_tmp70_ = _data13_->cell;
#line 156 "../src/sudoku-view.vala"
							g_signal_connect_object (_tmp70_, "will-open-popover", (GCallback) _________lambda13__sudoku_cell_will_open_popover, self, 0);
#line 160 "../src/sudoku-view.vala"
							_tmp71_ = self->priv->cells;
#line 160 "../src/sudoku-view.vala"
							_tmp71__length1 = self->priv->cells_length1;
#line 160 "../src/sudoku-view.vala"
							_tmp71__length2 = self->priv->cells_length2;
#line 160 "../src/sudoku-view.vala"
							_tmp72_ = _data13_->cell;
#line 160 "../src/sudoku-view.vala"
							_tmp73_ = _g_object_ref0 (_tmp72_);
#line 160 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp71_[(row * _tmp71__length2) + col]);
#line 160 "../src/sudoku-view.vala"
							_tmp71_[(row * _tmp71__length2) + col] = _tmp73_;
#line 161 "../src/sudoku-view.vala"
							_tmp74_ = self->priv->cells;
#line 161 "../src/sudoku-view.vala"
							_tmp74__length1 = self->priv->cells_length1;
#line 161 "../src/sudoku-view.vala"
							_tmp74__length2 = self->priv->cells_length2;
#line 161 "../src/sudoku-view.vala"
							_tmp75_ = _tmp74_[(row * _tmp74__length2) + col];
#line 161 "../src/sudoku-view.vala"
							_tmp76_ = sudoku_view_get_show_possibilities (self);
#line 161 "../src/sudoku-view.vala"
							_tmp77_ = _tmp76_;
#line 161 "../src/sudoku-view.vala"
							sudoku_cell_initialize_earmarks (_tmp75_, _tmp77_, FALSE);
#line 163 "../src/sudoku-view.vala"
							_tmp78_ = blocks;
#line 163 "../src/sudoku-view.vala"
							_tmp78__length1 = blocks_length1;
#line 163 "../src/sudoku-view.vala"
							_tmp78__length2 = blocks_length2;
#line 163 "../src/sudoku-view.vala"
							_tmp79_ = sudoku_game_get_board (_data12_->game);
#line 163 "../src/sudoku-view.vala"
							_tmp80_ = _tmp79_;
#line 163 "../src/sudoku-view.vala"
							_tmp81_ = sudoku_board_get_block_rows (_tmp80_);
#line 163 "../src/sudoku-view.vala"
							_tmp82_ = _tmp81_;
#line 163 "../src/sudoku-view.vala"
							_tmp83_ = sudoku_game_get_board (_data12_->game);
#line 163 "../src/sudoku-view.vala"
							_tmp84_ = _tmp83_;
#line 163 "../src/sudoku-view.vala"
							_tmp85_ = sudoku_board_get_block_cols (_tmp84_);
#line 163 "../src/sudoku-view.vala"
							_tmp86_ = _tmp85_;
#line 163 "../src/sudoku-view.vala"
							_tmp87_ = _tmp78_[((row / _tmp82_) * _tmp78__length2) + (col / _tmp86_)];
#line 163 "../src/sudoku-view.vala"
							_tmp88_ = _data13_->cell;
#line 163 "../src/sudoku-view.vala"
							_tmp89_ = sudoku_game_get_board (_data12_->game);
#line 163 "../src/sudoku-view.vala"
							_tmp90_ = _tmp89_;
#line 163 "../src/sudoku-view.vala"
							_tmp91_ = sudoku_board_get_block_cols (_tmp90_);
#line 163 "../src/sudoku-view.vala"
							_tmp92_ = _tmp91_;
#line 163 "../src/sudoku-view.vala"
							_tmp93_ = sudoku_game_get_board (_data12_->game);
#line 163 "../src/sudoku-view.vala"
							_tmp94_ = _tmp93_;
#line 163 "../src/sudoku-view.vala"
							_tmp95_ = sudoku_board_get_block_rows (_tmp94_);
#line 163 "../src/sudoku-view.vala"
							_tmp96_ = _tmp95_;
#line 163 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp87_, (GtkWidget*) _tmp88_, col % _tmp92_, row % _tmp96_, 1, 1);
#line 142 "../src/sudoku-view.vala"
							block13_data_unref (_data13_);
#line 142 "../src/sudoku-view.vala"
							_data13_ = NULL;
#line 1372 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 167 "../src/sudoku-view.vala"
	_tmp97_ = sudoku_view_get_game (self);
#line 167 "../src/sudoku-view.vala"
	_tmp98_ = _tmp97_;
#line 167 "../src/sudoku-view.vala"
	_tmp99_ = sudoku_game_get_board (_tmp98_);
#line 167 "../src/sudoku-view.vala"
	_tmp100_ = _tmp99_;
#line 167 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp100_, "cell-changed", (GCallback) _sudoku_view_cell_changed_cb_sudoku_board_cell_changed, self, 0);
#line 168 "../src/sudoku-view.vala"
	_tmp101_ = sudoku_view_get_game (self);
#line 168 "../src/sudoku-view.vala"
	_tmp102_ = _tmp101_;
#line 168 "../src/sudoku-view.vala"
	_tmp103_ = sudoku_game_get_board (_tmp102_);
#line 168 "../src/sudoku-view.vala"
	_tmp104_ = _tmp103_;
#line 168 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp104_, "earmark-changed", (GCallback) _sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed, self, 0);
#line 169 "../src/sudoku-view.vala"
	g_signal_connect_object (self, "selection-changed", (GCallback) _sudoku_view_selection_changed_cb_sudoku_view_selection_changed, self, 0);
#line 171 "../src/sudoku-view.vala"
	sudoku_view_update_warnings (self);
#line 172 "../src/sudoku-view.vala"
	_tmp105_ = self->priv->overlay;
#line 172 "../src/sudoku-view.vala"
	_tmp106_ = self->priv->paused;
#line 172 "../src/sudoku-view.vala"
	gtk_overlay_add_overlay (_tmp105_, (GtkWidget*) _tmp106_);
#line 173 "../src/sudoku-view.vala"
	_tmp107_ = self->priv->overlay;
#line 173 "../src/sudoku-view.vala"
	_tmp108_ = self->priv->grid;
#line 173 "../src/sudoku-view.vala"
	gtk_overlay_set_child (_tmp107_, (GtkWidget*) _tmp108_);
#line 174 "../src/sudoku-view.vala"
	_tmp109_ = self->priv->grid;
#line 174 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp109_);
#line 175 "../src/sudoku-view.vala"
	_tmp110_ = self->priv->overlay;
#line 175 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp110_);
#line 176 "../src/sudoku-view.vala"
	_tmp111_ = self->priv->paused;
#line 176 "../src/sudoku-view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp111_, FALSE);
#line 65 "../src/sudoku-view.vala"
	blocks = (_vala_array_free (blocks, blocks_length1 * blocks_length2, (GDestroyNotify) g_object_unref), NULL);
#line 65 "../src/sudoku-view.vala"
	_g_object_unref0 (frame);
#line 65 "../src/sudoku-view.vala"
	block12_data_unref (_data12_);
#line 65 "../src/sudoku-view.vala"
	_data12_ = NULL;
#line 65 "../src/sudoku-view.vala"
	return self;
#line 1437 "sudoku-view.c"
}

SudokuView*
sudoku_view_new (SudokuGame* game,
                 GSettings* settings)
{
#line 65 "../src/sudoku-view.vala"
	return sudoku_view_construct (TYPE_SUDOKU_VIEW, game, settings);
#line 1446 "sudoku-view.c"
}

static void
sudoku_view_selection_changed_cb (SudokuView* self,
                                  gint old_row,
                                  gint old_col,
                                  gint new_row,
                                  gint new_col)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	SudokuCell* _tmp1_;
#line 247 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 249 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, old_row, old_col, FALSE);
#line 250 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, new_row, new_col, TRUE);
#line 251 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 251 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 251 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 251 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_[(old_row * _tmp0__length2) + old_col];
#line 251 "../src/sudoku-view.vala"
	sudoku_cell_dismiss_popover (_tmp1_);
#line 1476 "sudoku-view.c"
}

static void
sudoku_view_cell_changed_cb (SudokuView* self,
                             gint row,
                             gint col,
                             gint old_val,
                             gint new_val)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	SudokuCell* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuCell** _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	SudokuCell* _tmp7_;
#line 254 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 256 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 256 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 256 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 256 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 256 "../src/sudoku-view.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 256 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_;
#line 256 "../src/sudoku-view.vala"
	if (!_tmp3_) {
#line 1512 "sudoku-view.c"
		SudokuCell** _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		SudokuCell* _tmp5_;
#line 257 "../src/sudoku-view.vala"
		_tmp4_ = self->priv->cells;
#line 257 "../src/sudoku-view.vala"
		_tmp4__length1 = self->priv->cells_length1;
#line 257 "../src/sudoku-view.vala"
		_tmp4__length2 = self->priv->cells_length2;
#line 257 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_[(row * _tmp4__length2) + col];
#line 257 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp5_);
#line 1527 "sudoku-view.c"
	}
#line 259 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->cells;
#line 259 "../src/sudoku-view.vala"
	_tmp6__length1 = self->priv->cells_length1;
#line 259 "../src/sudoku-view.vala"
	_tmp6__length2 = self->priv->cells_length2;
#line 259 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_[(row * _tmp6__length2) + col];
#line 259 "../src/sudoku-view.vala"
	sudoku_cell_update_value (_tmp7_);
#line 261 "../src/sudoku-view.vala"
	sudoku_view_update_warnings (self);
#line 262 "../src/sudoku-view.vala"
	sudoku_view_set_value_highlighter (self, old_val, FALSE);
#line 263 "../src/sudoku-view.vala"
	sudoku_view_set_value_highlighter (self, new_val, TRUE);
#line 1545 "sudoku-view.c"
}

static void
sudoku_view_earmark_changed_cb (SudokuView* self,
                                gint row,
                                gint col,
                                gint num,
                                gboolean enabled)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	SudokuCell* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuCell** _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	SudokuCell* _tmp7_;
#line 266 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 268 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 268 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 268 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 268 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 268 "../src/sudoku-view.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 268 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_;
#line 268 "../src/sudoku-view.vala"
	if (!_tmp3_) {
#line 1581 "sudoku-view.c"
		SudokuCell** _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		SudokuCell* _tmp5_;
#line 269 "../src/sudoku-view.vala"
		_tmp4_ = self->priv->cells;
#line 269 "../src/sudoku-view.vala"
		_tmp4__length1 = self->priv->cells_length1;
#line 269 "../src/sudoku-view.vala"
		_tmp4__length2 = self->priv->cells_length2;
#line 269 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_[(row * _tmp4__length2) + col];
#line 269 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp5_);
#line 1596 "sudoku-view.c"
	}
#line 271 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->cells;
#line 271 "../src/sudoku-view.vala"
	_tmp6__length1 = self->priv->cells_length1;
#line 271 "../src/sudoku-view.vala"
	_tmp6__length2 = self->priv->cells_length2;
#line 271 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_[(row * _tmp6__length2) + col];
#line 271 "../src/sudoku-view.vala"
	sudoku_cell_update_earmark (_tmp7_, num);
#line 272 "../src/sudoku-view.vala"
	if (enabled) {
#line 1610 "sudoku-view.c"
		SudokuCell** _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		SudokuCell* _tmp9_;
#line 273 "../src/sudoku-view.vala"
		_tmp8_ = self->priv->cells;
#line 273 "../src/sudoku-view.vala"
		_tmp8__length1 = self->priv->cells_length1;
#line 273 "../src/sudoku-view.vala"
		_tmp8__length2 = self->priv->cells_length2;
#line 273 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_[(row * _tmp8__length2) + col];
#line 273 "../src/sudoku-view.vala"
		sudoku_cell_check_earmark_warnings (_tmp9_, num);
#line 1625 "sudoku-view.c"
	}
}

static void
sudoku_view_set_cell_highlighter (SudokuView* self,
                                  gint row,
                                  gint col,
                                  gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuCell* cell = NULL;
	SudokuCell** _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	SudokuCell* _tmp3_;
	SudokuCell* _tmp4_;
#line 276 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_highlighter (self);
#line 278 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 278 "../src/sudoku-view.vala"
	if (!_tmp1_) {
#line 279 "../src/sudoku-view.vala"
		return;
#line 1653 "sudoku-view.c"
	}
#line 281 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->cells;
#line 281 "../src/sudoku-view.vala"
	_tmp2__length1 = self->priv->cells_length1;
#line 281 "../src/sudoku-view.vala"
	_tmp2__length2 = self->priv->cells_length2;
#line 281 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_[(row * _tmp2__length2) + col];
#line 281 "../src/sudoku-view.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 281 "../src/sudoku-view.vala"
	cell = _tmp4_;
#line 1667 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 283 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 1672 "sudoku-view.c"
		{
			gboolean _tmp5_ = FALSE;
#line 283 "../src/sudoku-view.vala"
			_tmp5_ = TRUE;
#line 283 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1679 "sudoku-view.c"
				SudokuGame* _tmp7_;
				SudokuGame* _tmp8_;
				SudokuBoard* _tmp9_;
				SudokuBoard* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
#line 283 "../src/sudoku-view.vala"
				if (!_tmp5_) {
#line 1688 "sudoku-view.c"
					gint _tmp6_;
#line 283 "../src/sudoku-view.vala"
					_tmp6_ = col_tmp;
#line 283 "../src/sudoku-view.vala"
					col_tmp = _tmp6_ + 1;
#line 1694 "sudoku-view.c"
				}
#line 283 "../src/sudoku-view.vala"
				_tmp5_ = FALSE;
#line 283 "../src/sudoku-view.vala"
				_tmp7_ = sudoku_view_get_game (self);
#line 283 "../src/sudoku-view.vala"
				_tmp8_ = _tmp7_;
#line 283 "../src/sudoku-view.vala"
				_tmp9_ = sudoku_game_get_board (_tmp8_);
#line 283 "../src/sudoku-view.vala"
				_tmp10_ = _tmp9_;
#line 283 "../src/sudoku-view.vala"
				_tmp11_ = sudoku_board_get_cols (_tmp10_);
#line 283 "../src/sudoku-view.vala"
				_tmp12_ = _tmp11_;
#line 283 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp12_)) {
#line 283 "../src/sudoku-view.vala"
					break;
#line 1714 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 285 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 1720 "sudoku-view.c"
					{
						gboolean _tmp13_ = FALSE;
#line 285 "../src/sudoku-view.vala"
						_tmp13_ = TRUE;
#line 285 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1727 "sudoku-view.c"
							SudokuGame* _tmp15_;
							SudokuGame* _tmp16_;
							SudokuBoard* _tmp17_;
							SudokuBoard* _tmp18_;
							gint _tmp19_;
							gint _tmp20_;
							SudokuCell* cell_tmp = NULL;
							SudokuCell** _tmp21_;
							gint _tmp21__length1;
							gint _tmp21__length2;
							SudokuCell* _tmp22_;
							SudokuCell* _tmp23_;
							SudokuCell* _tmp24_;
							SudokuCell* _tmp25_;
							SudokuCell* _tmp26_;
							gint _tmp27_;
							gint _tmp28_;
							gboolean _tmp43_ = FALSE;
							SudokuCell* _tmp44_;
							gboolean _tmp45_;
							gboolean _tmp46_;
#line 285 "../src/sudoku-view.vala"
							if (!_tmp13_) {
#line 1751 "sudoku-view.c"
								gint _tmp14_;
#line 285 "../src/sudoku-view.vala"
								_tmp14_ = row_tmp;
#line 285 "../src/sudoku-view.vala"
								row_tmp = _tmp14_ + 1;
#line 1757 "sudoku-view.c"
							}
#line 285 "../src/sudoku-view.vala"
							_tmp13_ = FALSE;
#line 285 "../src/sudoku-view.vala"
							_tmp15_ = sudoku_view_get_game (self);
#line 285 "../src/sudoku-view.vala"
							_tmp16_ = _tmp15_;
#line 285 "../src/sudoku-view.vala"
							_tmp17_ = sudoku_game_get_board (_tmp16_);
#line 285 "../src/sudoku-view.vala"
							_tmp18_ = _tmp17_;
#line 285 "../src/sudoku-view.vala"
							_tmp19_ = sudoku_board_get_rows (_tmp18_);
#line 285 "../src/sudoku-view.vala"
							_tmp20_ = _tmp19_;
#line 285 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp20_)) {
#line 285 "../src/sudoku-view.vala"
								break;
#line 1777 "sudoku-view.c"
							}
#line 287 "../src/sudoku-view.vala"
							_tmp21_ = self->priv->cells;
#line 287 "../src/sudoku-view.vala"
							_tmp21__length1 = self->priv->cells_length1;
#line 287 "../src/sudoku-view.vala"
							_tmp21__length2 = self->priv->cells_length2;
#line 287 "../src/sudoku-view.vala"
							_tmp22_ = _tmp21_[(row_tmp * _tmp21__length2) + col_tmp];
#line 287 "../src/sudoku-view.vala"
							_tmp23_ = _g_object_ref0 (_tmp22_);
#line 287 "../src/sudoku-view.vala"
							cell_tmp = _tmp23_;
#line 289 "../src/sudoku-view.vala"
							_tmp24_ = cell;
#line 289 "../src/sudoku-view.vala"
							_tmp25_ = cell_tmp;
#line 289 "../src/sudoku-view.vala"
							if (_tmp24_ == _tmp25_) {
#line 290 "../src/sudoku-view.vala"
								_g_object_unref0 (cell_tmp);
#line 290 "../src/sudoku-view.vala"
								continue;
#line 1801 "sudoku-view.c"
							}
#line 292 "../src/sudoku-view.vala"
							_tmp26_ = cell;
#line 292 "../src/sudoku-view.vala"
							_tmp27_ = sudoku_cell_get_value (_tmp26_);
#line 292 "../src/sudoku-view.vala"
							_tmp28_ = _tmp27_;
#line 292 "../src/sudoku-view.vala"
							if (_tmp28_ > 0) {
#line 1811 "sudoku-view.c"
								SudokuCell* _tmp29_;
								gint _tmp30_;
								gint _tmp31_;
								SudokuCell* _tmp32_;
								gint _tmp33_;
								gint _tmp34_;
#line 294 "../src/sudoku-view.vala"
								_tmp29_ = cell;
#line 294 "../src/sudoku-view.vala"
								_tmp30_ = sudoku_cell_get_value (_tmp29_);
#line 294 "../src/sudoku-view.vala"
								_tmp31_ = _tmp30_;
#line 294 "../src/sudoku-view.vala"
								_tmp32_ = cell_tmp;
#line 294 "../src/sudoku-view.vala"
								_tmp33_ = sudoku_cell_get_value (_tmp32_);
#line 294 "../src/sudoku-view.vala"
								_tmp34_ = _tmp33_;
#line 294 "../src/sudoku-view.vala"
								if (_tmp31_ == _tmp34_) {
#line 1832 "sudoku-view.c"
									SudokuCell* _tmp35_;
#line 295 "../src/sudoku-view.vala"
									_tmp35_ = cell_tmp;
#line 295 "../src/sudoku-view.vala"
									sudoku_cell_set_highlighted_value (_tmp35_, enabled);
#line 1838 "sudoku-view.c"
								} else {
									SudokuCell* _tmp36_;
									gint _tmp37_;
									gint _tmp38_;
#line 296 "../src/sudoku-view.vala"
									_tmp36_ = cell_tmp;
#line 296 "../src/sudoku-view.vala"
									_tmp37_ = sudoku_cell_get_value (_tmp36_);
#line 296 "../src/sudoku-view.vala"
									_tmp38_ = _tmp37_;
#line 296 "../src/sudoku-view.vala"
									if (_tmp38_ == 0) {
#line 1851 "sudoku-view.c"
										SudokuCell* _tmp39_;
										SudokuCell* _tmp40_;
										gint _tmp41_;
										gint _tmp42_;
#line 297 "../src/sudoku-view.vala"
										_tmp39_ = cell_tmp;
#line 297 "../src/sudoku-view.vala"
										_tmp40_ = cell;
#line 297 "../src/sudoku-view.vala"
										_tmp41_ = sudoku_cell_get_value (_tmp40_);
#line 297 "../src/sudoku-view.vala"
										_tmp42_ = _tmp41_;
#line 297 "../src/sudoku-view.vala"
										sudoku_cell_set_earmark_highlight (_tmp39_, _tmp42_, enabled);
#line 1866 "sudoku-view.c"
									}
								}
							}
#line 300 "../src/sudoku-view.vala"
							_tmp44_ = cell_tmp;
#line 300 "../src/sudoku-view.vala"
							_tmp45_ = sudoku_cell_get_is_fixed (_tmp44_);
#line 300 "../src/sudoku-view.vala"
							_tmp46_ = _tmp45_;
#line 300 "../src/sudoku-view.vala"
							if (!_tmp46_) {
#line 1878 "sudoku-view.c"
								gboolean _tmp47_ = FALSE;
								gboolean _tmp48_ = FALSE;
#line 301 "../src/sudoku-view.vala"
								if (row_tmp == row) {
#line 301 "../src/sudoku-view.vala"
									_tmp48_ = TRUE;
#line 1885 "sudoku-view.c"
								} else {
#line 301 "../src/sudoku-view.vala"
									_tmp48_ = col_tmp == col;
#line 1889 "sudoku-view.c"
								}
#line 301 "../src/sudoku-view.vala"
								if (_tmp48_) {
#line 301 "../src/sudoku-view.vala"
									_tmp47_ = TRUE;
#line 1895 "sudoku-view.c"
								} else {
									gboolean _tmp49_ = FALSE;
									SudokuGame* _tmp50_;
									SudokuGame* _tmp51_;
									SudokuBoard* _tmp52_;
									SudokuBoard* _tmp53_;
									gint _tmp54_;
									gint _tmp55_;
									SudokuGame* _tmp56_;
									SudokuGame* _tmp57_;
									SudokuBoard* _tmp58_;
									SudokuBoard* _tmp59_;
									gint _tmp60_;
									gint _tmp61_;
#line 302 "../src/sudoku-view.vala"
									_tmp50_ = sudoku_view_get_game (self);
#line 302 "../src/sudoku-view.vala"
									_tmp51_ = _tmp50_;
#line 302 "../src/sudoku-view.vala"
									_tmp52_ = sudoku_game_get_board (_tmp51_);
#line 302 "../src/sudoku-view.vala"
									_tmp53_ = _tmp52_;
#line 302 "../src/sudoku-view.vala"
									_tmp54_ = sudoku_board_get_block_cols (_tmp53_);
#line 302 "../src/sudoku-view.vala"
									_tmp55_ = _tmp54_;
#line 302 "../src/sudoku-view.vala"
									_tmp56_ = sudoku_view_get_game (self);
#line 302 "../src/sudoku-view.vala"
									_tmp57_ = _tmp56_;
#line 302 "../src/sudoku-view.vala"
									_tmp58_ = sudoku_game_get_board (_tmp57_);
#line 302 "../src/sudoku-view.vala"
									_tmp59_ = _tmp58_;
#line 302 "../src/sudoku-view.vala"
									_tmp60_ = sudoku_board_get_block_cols (_tmp59_);
#line 302 "../src/sudoku-view.vala"
									_tmp61_ = _tmp60_;
#line 302 "../src/sudoku-view.vala"
									if ((row_tmp / _tmp55_) == (row / _tmp61_)) {
#line 1936 "sudoku-view.c"
										SudokuGame* _tmp62_;
										SudokuGame* _tmp63_;
										SudokuBoard* _tmp64_;
										SudokuBoard* _tmp65_;
										gint _tmp66_;
										gint _tmp67_;
										SudokuGame* _tmp68_;
										SudokuGame* _tmp69_;
										SudokuBoard* _tmp70_;
										SudokuBoard* _tmp71_;
										gint _tmp72_;
										gint _tmp73_;
#line 303 "../src/sudoku-view.vala"
										_tmp62_ = sudoku_view_get_game (self);
#line 303 "../src/sudoku-view.vala"
										_tmp63_ = _tmp62_;
#line 303 "../src/sudoku-view.vala"
										_tmp64_ = sudoku_game_get_board (_tmp63_);
#line 303 "../src/sudoku-view.vala"
										_tmp65_ = _tmp64_;
#line 303 "../src/sudoku-view.vala"
										_tmp66_ = sudoku_board_get_block_rows (_tmp65_);
#line 303 "../src/sudoku-view.vala"
										_tmp67_ = _tmp66_;
#line 303 "../src/sudoku-view.vala"
										_tmp68_ = sudoku_view_get_game (self);
#line 303 "../src/sudoku-view.vala"
										_tmp69_ = _tmp68_;
#line 303 "../src/sudoku-view.vala"
										_tmp70_ = sudoku_game_get_board (_tmp69_);
#line 303 "../src/sudoku-view.vala"
										_tmp71_ = _tmp70_;
#line 303 "../src/sudoku-view.vala"
										_tmp72_ = sudoku_board_get_block_rows (_tmp71_);
#line 303 "../src/sudoku-view.vala"
										_tmp73_ = _tmp72_;
#line 303 "../src/sudoku-view.vala"
										_tmp49_ = (col_tmp / _tmp67_) == (col / _tmp73_);
#line 1975 "sudoku-view.c"
									} else {
#line 302 "../src/sudoku-view.vala"
										_tmp49_ = FALSE;
#line 1979 "sudoku-view.c"
									}
#line 302 "../src/sudoku-view.vala"
									_tmp47_ = _tmp49_;
#line 1983 "sudoku-view.c"
								}
#line 301 "../src/sudoku-view.vala"
								_tmp43_ = _tmp47_;
#line 1987 "sudoku-view.c"
							} else {
#line 300 "../src/sudoku-view.vala"
								_tmp43_ = FALSE;
#line 1991 "sudoku-view.c"
							}
#line 300 "../src/sudoku-view.vala"
							if (_tmp43_) {
#line 1995 "sudoku-view.c"
								SudokuCell* _tmp74_;
#line 305 "../src/sudoku-view.vala"
								_tmp74_ = cell_tmp;
#line 305 "../src/sudoku-view.vala"
								sudoku_cell_set_highlighted_background (_tmp74_, enabled);
#line 2001 "sudoku-view.c"
							}
#line 285 "../src/sudoku-view.vala"
							_g_object_unref0 (cell_tmp);
#line 2005 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 276 "../src/sudoku-view.vala"
	_g_object_unref0 (cell);
#line 2014 "sudoku-view.c"
}

static void
sudoku_view_set_value_highlighter (SudokuView* self,
                                   gint val,
                                   gboolean enabled)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	SudokuCell* cell = NULL;
	SudokuCell** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	gint _tmp4_;
	gint _tmp5_;
	SudokuCell* _tmp6_;
	SudokuCell* _tmp7_;
#line 311 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 313 "../src/sudoku-view.vala"
	_tmp1_ = sudoku_view_get_highlighter (self);
#line 313 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 313 "../src/sudoku-view.vala"
	if (!_tmp2_) {
#line 313 "../src/sudoku-view.vala"
		_tmp0_ = TRUE;
#line 2043 "sudoku-view.c"
	} else {
#line 313 "../src/sudoku-view.vala"
		_tmp0_ = val == 0;
#line 2047 "sudoku-view.c"
	}
#line 313 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 314 "../src/sudoku-view.vala"
		return;
#line 2053 "sudoku-view.c"
	}
#line 316 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->cells;
#line 316 "../src/sudoku-view.vala"
	_tmp3__length1 = self->priv->cells_length1;
#line 316 "../src/sudoku-view.vala"
	_tmp3__length2 = self->priv->cells_length2;
#line 316 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->_selected_row;
#line 316 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->_selected_col;
#line 316 "../src/sudoku-view.vala"
	_tmp6_ = _tmp3_[(_tmp4_ * _tmp3__length2) + _tmp5_];
#line 316 "../src/sudoku-view.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 316 "../src/sudoku-view.vala"
	cell = _tmp7_;
#line 2071 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 318 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 2076 "sudoku-view.c"
		{
			gboolean _tmp8_ = FALSE;
#line 318 "../src/sudoku-view.vala"
			_tmp8_ = TRUE;
#line 318 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2083 "sudoku-view.c"
				SudokuGame* _tmp10_;
				SudokuGame* _tmp11_;
				SudokuBoard* _tmp12_;
				SudokuBoard* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
#line 318 "../src/sudoku-view.vala"
				if (!_tmp8_) {
#line 2092 "sudoku-view.c"
					gint _tmp9_;
#line 318 "../src/sudoku-view.vala"
					_tmp9_ = col_tmp;
#line 318 "../src/sudoku-view.vala"
					col_tmp = _tmp9_ + 1;
#line 2098 "sudoku-view.c"
				}
#line 318 "../src/sudoku-view.vala"
				_tmp8_ = FALSE;
#line 318 "../src/sudoku-view.vala"
				_tmp10_ = sudoku_view_get_game (self);
#line 318 "../src/sudoku-view.vala"
				_tmp11_ = _tmp10_;
#line 318 "../src/sudoku-view.vala"
				_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 318 "../src/sudoku-view.vala"
				_tmp13_ = _tmp12_;
#line 318 "../src/sudoku-view.vala"
				_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 318 "../src/sudoku-view.vala"
				_tmp15_ = _tmp14_;
#line 318 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp15_)) {
#line 318 "../src/sudoku-view.vala"
					break;
#line 2118 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 320 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 2124 "sudoku-view.c"
					{
						gboolean _tmp16_ = FALSE;
#line 320 "../src/sudoku-view.vala"
						_tmp16_ = TRUE;
#line 320 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2131 "sudoku-view.c"
							SudokuGame* _tmp18_;
							SudokuGame* _tmp19_;
							SudokuBoard* _tmp20_;
							SudokuBoard* _tmp21_;
							gint _tmp22_;
							gint _tmp23_;
							SudokuCell* cell_tmp = NULL;
							SudokuCell** _tmp24_;
							gint _tmp24__length1;
							gint _tmp24__length2;
							SudokuCell* _tmp25_;
							SudokuCell* _tmp26_;
							SudokuCell* _tmp27_;
							SudokuCell* _tmp28_;
							SudokuCell* _tmp29_;
							gint _tmp30_;
							gint _tmp31_;
#line 320 "../src/sudoku-view.vala"
							if (!_tmp16_) {
#line 2151 "sudoku-view.c"
								gint _tmp17_;
#line 320 "../src/sudoku-view.vala"
								_tmp17_ = row_tmp;
#line 320 "../src/sudoku-view.vala"
								row_tmp = _tmp17_ + 1;
#line 2157 "sudoku-view.c"
							}
#line 320 "../src/sudoku-view.vala"
							_tmp16_ = FALSE;
#line 320 "../src/sudoku-view.vala"
							_tmp18_ = sudoku_view_get_game (self);
#line 320 "../src/sudoku-view.vala"
							_tmp19_ = _tmp18_;
#line 320 "../src/sudoku-view.vala"
							_tmp20_ = sudoku_game_get_board (_tmp19_);
#line 320 "../src/sudoku-view.vala"
							_tmp21_ = _tmp20_;
#line 320 "../src/sudoku-view.vala"
							_tmp22_ = sudoku_board_get_rows (_tmp21_);
#line 320 "../src/sudoku-view.vala"
							_tmp23_ = _tmp22_;
#line 320 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp23_)) {
#line 320 "../src/sudoku-view.vala"
								break;
#line 2177 "sudoku-view.c"
							}
#line 322 "../src/sudoku-view.vala"
							_tmp24_ = self->priv->cells;
#line 322 "../src/sudoku-view.vala"
							_tmp24__length1 = self->priv->cells_length1;
#line 322 "../src/sudoku-view.vala"
							_tmp24__length2 = self->priv->cells_length2;
#line 322 "../src/sudoku-view.vala"
							_tmp25_ = _tmp24_[(row_tmp * _tmp24__length2) + col_tmp];
#line 322 "../src/sudoku-view.vala"
							_tmp26_ = _g_object_ref0 (_tmp25_);
#line 322 "../src/sudoku-view.vala"
							cell_tmp = _tmp26_;
#line 324 "../src/sudoku-view.vala"
							_tmp27_ = cell;
#line 324 "../src/sudoku-view.vala"
							_tmp28_ = cell_tmp;
#line 324 "../src/sudoku-view.vala"
							if (_tmp27_ == _tmp28_) {
#line 325 "../src/sudoku-view.vala"
								_g_object_unref0 (cell_tmp);
#line 325 "../src/sudoku-view.vala"
								continue;
#line 2201 "sudoku-view.c"
							}
#line 327 "../src/sudoku-view.vala"
							_tmp29_ = cell_tmp;
#line 327 "../src/sudoku-view.vala"
							_tmp30_ = sudoku_cell_get_value (_tmp29_);
#line 327 "../src/sudoku-view.vala"
							_tmp31_ = _tmp30_;
#line 327 "../src/sudoku-view.vala"
							if (val == _tmp31_) {
#line 2211 "sudoku-view.c"
								SudokuCell* _tmp32_;
#line 328 "../src/sudoku-view.vala"
								_tmp32_ = cell_tmp;
#line 328 "../src/sudoku-view.vala"
								sudoku_cell_set_highlighted_value (_tmp32_, enabled);
#line 2217 "sudoku-view.c"
							} else {
								SudokuCell* _tmp33_;
								gint _tmp34_;
								gint _tmp35_;
#line 329 "../src/sudoku-view.vala"
								_tmp33_ = cell_tmp;
#line 329 "../src/sudoku-view.vala"
								_tmp34_ = sudoku_cell_get_value (_tmp33_);
#line 329 "../src/sudoku-view.vala"
								_tmp35_ = _tmp34_;
#line 329 "../src/sudoku-view.vala"
								if (_tmp35_ == 0) {
#line 2230 "sudoku-view.c"
									SudokuCell* _tmp36_;
#line 330 "../src/sudoku-view.vala"
									_tmp36_ = cell_tmp;
#line 330 "../src/sudoku-view.vala"
									sudoku_cell_set_earmark_highlight (_tmp36_, val, enabled);
#line 2236 "sudoku-view.c"
								}
							}
#line 320 "../src/sudoku-view.vala"
							_g_object_unref0 (cell_tmp);
#line 2241 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 311 "../src/sudoku-view.vala"
	_g_object_unref0 (cell);
#line 2250 "sudoku-view.c"
}

static void
sudoku_view_update_warnings (SudokuView* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 335 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 337 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 337 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 337 "../src/sudoku-view.vala"
	if (!_tmp1_) {
#line 338 "../src/sudoku-view.vala"
		return;
#line 2268 "sudoku-view.c"
	}
	{
		gint col = 0;
#line 340 "../src/sudoku-view.vala"
		col = 0;
#line 2274 "sudoku-view.c"
		{
			gboolean _tmp2_ = FALSE;
#line 340 "../src/sudoku-view.vala"
			_tmp2_ = TRUE;
#line 340 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2281 "sudoku-view.c"
				SudokuGame* _tmp4_;
				SudokuGame* _tmp5_;
				SudokuBoard* _tmp6_;
				SudokuBoard* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
#line 340 "../src/sudoku-view.vala"
				if (!_tmp2_) {
#line 2290 "sudoku-view.c"
					gint _tmp3_;
#line 340 "../src/sudoku-view.vala"
					_tmp3_ = col;
#line 340 "../src/sudoku-view.vala"
					col = _tmp3_ + 1;
#line 2296 "sudoku-view.c"
				}
#line 340 "../src/sudoku-view.vala"
				_tmp2_ = FALSE;
#line 340 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_view_get_game (self);
#line 340 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 340 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_game_get_board (_tmp5_);
#line 340 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 340 "../src/sudoku-view.vala"
				_tmp8_ = sudoku_board_get_cols (_tmp7_);
#line 340 "../src/sudoku-view.vala"
				_tmp9_ = _tmp8_;
#line 340 "../src/sudoku-view.vala"
				if (!(col < _tmp9_)) {
#line 340 "../src/sudoku-view.vala"
					break;
#line 2316 "sudoku-view.c"
				}
				{
					gint row = 0;
#line 341 "../src/sudoku-view.vala"
					row = 0;
#line 2322 "sudoku-view.c"
					{
						gboolean _tmp10_ = FALSE;
#line 341 "../src/sudoku-view.vala"
						_tmp10_ = TRUE;
#line 341 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2329 "sudoku-view.c"
							SudokuGame* _tmp12_;
							SudokuGame* _tmp13_;
							SudokuBoard* _tmp14_;
							SudokuBoard* _tmp15_;
							gint _tmp16_;
							gint _tmp17_;
							SudokuCell** _tmp18_;
							gint _tmp18__length1;
							gint _tmp18__length2;
							SudokuCell* _tmp19_;
							gboolean _tmp20_;
							gboolean _tmp21_;
							SudokuCell** _tmp22_;
							gint _tmp22__length1;
							gint _tmp22__length2;
							SudokuCell* _tmp23_;
#line 341 "../src/sudoku-view.vala"
							if (!_tmp10_) {
#line 2348 "sudoku-view.c"
								gint _tmp11_;
#line 341 "../src/sudoku-view.vala"
								_tmp11_ = row;
#line 341 "../src/sudoku-view.vala"
								row = _tmp11_ + 1;
#line 2354 "sudoku-view.c"
							}
#line 341 "../src/sudoku-view.vala"
							_tmp10_ = FALSE;
#line 341 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_view_get_game (self);
#line 341 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 341 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_game_get_board (_tmp13_);
#line 341 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 341 "../src/sudoku-view.vala"
							_tmp16_ = sudoku_board_get_rows (_tmp15_);
#line 341 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_;
#line 341 "../src/sudoku-view.vala"
							if (!(row < _tmp17_)) {
#line 341 "../src/sudoku-view.vala"
								break;
#line 2374 "sudoku-view.c"
							}
#line 343 "../src/sudoku-view.vala"
							_tmp18_ = self->priv->cells;
#line 343 "../src/sudoku-view.vala"
							_tmp18__length1 = self->priv->cells_length1;
#line 343 "../src/sudoku-view.vala"
							_tmp18__length2 = self->priv->cells_length2;
#line 343 "../src/sudoku-view.vala"
							_tmp19_ = _tmp18_[(row * _tmp18__length2) + col];
#line 343 "../src/sudoku-view.vala"
							_tmp20_ = sudoku_view_get_show_extra_warnings (self);
#line 343 "../src/sudoku-view.vala"
							_tmp21_ = _tmp20_;
#line 343 "../src/sudoku-view.vala"
							sudoku_cell_check_value_warnings (_tmp19_, _tmp21_);
#line 344 "../src/sudoku-view.vala"
							_tmp22_ = self->priv->cells;
#line 344 "../src/sudoku-view.vala"
							_tmp22__length1 = self->priv->cells_length1;
#line 344 "../src/sudoku-view.vala"
							_tmp22__length2 = self->priv->cells_length2;
#line 344 "../src/sudoku-view.vala"
							_tmp23_ = _tmp22_[(row * _tmp22__length2) + col];
#line 344 "../src/sudoku-view.vala"
							sudoku_cell_check_earmarks_warnings (_tmp23_);
#line 2400 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_clear (SudokuView* self)
{
#line 348 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2414 "sudoku-view.c"
	{
		gint i = 0;
#line 350 "../src/sudoku-view.vala"
		i = 0;
#line 2419 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 350 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 350 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2426 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 350 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2435 "sudoku-view.c"
					gint _tmp1_;
#line 350 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 350 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2441 "sudoku-view.c"
				}
#line 350 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 350 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 350 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 350 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 350 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 350 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 350 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 350 "../src/sudoku-view.vala"
				if (!(i < _tmp7_)) {
#line 350 "../src/sudoku-view.vala"
					break;
#line 2461 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 351 "../src/sudoku-view.vala"
					j = 0;
#line 2467 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 351 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 351 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2474 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuGame* _tmp16_;
							SudokuGame* _tmp17_;
							SudokuBoard* _tmp18_;
							SudokuBoard* _tmp19_;
#line 351 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 2487 "sudoku-view.c"
								gint _tmp9_;
#line 351 "../src/sudoku-view.vala"
								_tmp9_ = j;
#line 351 "../src/sudoku-view.vala"
								j = _tmp9_ + 1;
#line 2493 "sudoku-view.c"
							}
#line 351 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 351 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 351 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 351 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 351 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 351 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 351 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 351 "../src/sudoku-view.vala"
							if (!(j < _tmp15_)) {
#line 351 "../src/sudoku-view.vala"
								break;
#line 2513 "sudoku-view.c"
							}
#line 352 "../src/sudoku-view.vala"
							_tmp16_ = sudoku_view_get_game (self);
#line 352 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_;
#line 352 "../src/sudoku-view.vala"
							_tmp18_ = sudoku_game_get_board (_tmp17_);
#line 352 "../src/sudoku-view.vala"
							_tmp19_ = _tmp18_;
#line 352 "../src/sudoku-view.vala"
							sudoku_board_disable_all_earmarks (_tmp19_, i, j);
#line 2525 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_clear_all_warnings (SudokuView* self)
{
#line 355 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2539 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 357 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 2544 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 357 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 357 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2551 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 357 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2560 "sudoku-view.c"
					gint _tmp1_;
#line 357 "../src/sudoku-view.vala"
					_tmp1_ = col_tmp;
#line 357 "../src/sudoku-view.vala"
					col_tmp = _tmp1_ + 1;
#line 2566 "sudoku-view.c"
				}
#line 357 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 357 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 357 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 357 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 357 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 357 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_cols (_tmp5_);
#line 357 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 357 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp7_)) {
#line 357 "../src/sudoku-view.vala"
					break;
#line 2586 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 358 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 2592 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 358 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 358 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2599 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
#line 358 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 2612 "sudoku-view.c"
								gint _tmp9_;
#line 358 "../src/sudoku-view.vala"
								_tmp9_ = row_tmp;
#line 358 "../src/sudoku-view.vala"
								row_tmp = _tmp9_ + 1;
#line 2618 "sudoku-view.c"
							}
#line 358 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 358 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 358 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 358 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 358 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 358 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_rows (_tmp13_);
#line 358 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 358 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp15_)) {
#line 358 "../src/sudoku-view.vala"
								break;
#line 2638 "sudoku-view.c"
							}
#line 359 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 359 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 359 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 359 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(row_tmp * _tmp16__length2) + col_tmp];
#line 359 "../src/sudoku-view.vala"
							sudoku_cell_clear_warnings (_tmp17_);
#line 2650 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_dismiss_popovers (SudokuView* self)
{
#line 434 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2664 "sudoku-view.c"
	{
		gint i = 0;
#line 436 "../src/sudoku-view.vala"
		i = 0;
#line 2669 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 436 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 436 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2676 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 436 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2685 "sudoku-view.c"
					gint _tmp1_;
#line 436 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 436 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2691 "sudoku-view.c"
				}
#line 436 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 436 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 436 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 436 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 436 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 436 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 436 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 436 "../src/sudoku-view.vala"
				if (!(i < _tmp7_)) {
#line 436 "../src/sudoku-view.vala"
					break;
#line 2711 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 437 "../src/sudoku-view.vala"
					j = 0;
#line 2717 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 437 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 437 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2724 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
#line 437 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 2737 "sudoku-view.c"
								gint _tmp9_;
#line 437 "../src/sudoku-view.vala"
								_tmp9_ = j;
#line 437 "../src/sudoku-view.vala"
								j = _tmp9_ + 1;
#line 2743 "sudoku-view.c"
							}
#line 437 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 437 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 437 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 437 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 437 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 437 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 437 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 437 "../src/sudoku-view.vala"
							if (!(j < _tmp15_)) {
#line 437 "../src/sudoku-view.vala"
								break;
#line 2763 "sudoku-view.c"
							}
#line 438 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 438 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 438 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 438 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(i * _tmp16__length2) + j];
#line 438 "../src/sudoku-view.vala"
							sudoku_cell_dismiss_popover (_tmp17_);
#line 2775 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

SudokuGame*
sudoku_view_get_game (SudokuView* self)
{
	SudokuGame* result;
	SudokuGame* _tmp0_;
#line 31 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->_game;
#line 31 "../src/sudoku-view.vala"
	result = _tmp0_;
#line 31 "../src/sudoku-view.vala"
	return result;
#line 2797 "sudoku-view.c"
}

static void
sudoku_view_set_game (SudokuView* self,
                      SudokuGame* value)
{
	SudokuGame* _tmp0_;
#line 32 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 32 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 32 "../src/sudoku-view.vala"
	self->priv->_game = _tmp0_;
#line 32 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_GAME_PROPERTY]);
#line 2815 "sudoku-view.c"
}

gint
sudoku_view_get_selected_row (SudokuView* self)
{
	gint result;
#line 41 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 41 "../src/sudoku-view.vala"
	result = self->priv->_selected_row;
#line 41 "../src/sudoku-view.vala"
	return result;
#line 2828 "sudoku-view.c"
}

static void
sudoku_view_set_selected_row (SudokuView* self,
                              gint value)
{
	gint old_value;
#line 41 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/sudoku-view.vala"
	old_value = sudoku_view_get_selected_row (self);
#line 41 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 41 "../src/sudoku-view.vala"
		self->priv->_selected_row = value;
#line 41 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY]);
#line 2846 "sudoku-view.c"
	}
}

gint
sudoku_view_get_selected_col (SudokuView* self)
{
	gint result;
#line 42 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "../src/sudoku-view.vala"
	result = self->priv->_selected_col;
#line 42 "../src/sudoku-view.vala"
	return result;
#line 2860 "sudoku-view.c"
}

static void
sudoku_view_set_selected_col (SudokuView* self,
                              gint value)
{
	gint old_value;
#line 42 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/sudoku-view.vala"
	old_value = sudoku_view_get_selected_col (self);
#line 42 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 42 "../src/sudoku-view.vala"
		self->priv->_selected_col = value;
#line 42 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY]);
#line 2878 "sudoku-view.c"
	}
}

gboolean
sudoku_view_get_show_warnings (SudokuView* self)
{
	gboolean result;
#line 365 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 365 "../src/sudoku-view.vala"
	result = self->priv->_show_warnings;
#line 365 "../src/sudoku-view.vala"
	return result;
#line 2892 "sudoku-view.c"
}

void
sudoku_view_set_show_warnings (SudokuView* self,
                               gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 366 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 367 "../src/sudoku-view.vala"
	self->priv->_show_warnings = value;
#line 369 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 369 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 369 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 370 "../src/sudoku-view.vala"
		sudoku_view_update_warnings (self);
#line 2915 "sudoku-view.c"
	} else {
#line 372 "../src/sudoku-view.vala"
		sudoku_view_clear_all_warnings (self);
#line 2919 "sudoku-view.c"
	}
#line 374 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->_selected_row;
#line 374 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->_selected_col;
#line 374 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp2_, _tmp3_, TRUE);
#line 366 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY]);
#line 2929 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_extra_warnings (SudokuView* self)
{
	gboolean result;
#line 381 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 381 "../src/sudoku-view.vala"
	result = self->priv->_show_extra_warnings;
#line 381 "../src/sudoku-view.vala"
	return result;
#line 2942 "sudoku-view.c"
}

void
sudoku_view_set_show_extra_warnings (SudokuView* self,
                                     gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 382 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 383 "../src/sudoku-view.vala"
	self->priv->_show_extra_warnings = value;
#line 384 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 384 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 384 "../src/sudoku-view.vala"
	sudoku_view_set_show_warnings (self, _tmp1_);
#line 382 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY]);
#line 2963 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_possibilities (SudokuView* self)
{
	gboolean result;
#line 391 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 391 "../src/sudoku-view.vala"
	result = self->priv->_show_possibilities;
#line 391 "../src/sudoku-view.vala"
	return result;
#line 2976 "sudoku-view.c"
}

void
sudoku_view_set_show_possibilities (SudokuView* self,
                                    gboolean value)
{
#line 392 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 393 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = value;
#line 2987 "sudoku-view.c"
	{
		gint row = 0;
#line 394 "../src/sudoku-view.vala"
		row = 0;
#line 2992 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 394 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 394 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2999 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 394 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 3008 "sudoku-view.c"
					gint _tmp1_;
#line 394 "../src/sudoku-view.vala"
					_tmp1_ = row;
#line 394 "../src/sudoku-view.vala"
					row = _tmp1_ + 1;
#line 3014 "sudoku-view.c"
				}
#line 394 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 394 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 394 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 394 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 394 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 394 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 394 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 394 "../src/sudoku-view.vala"
				if (!(row < _tmp7_)) {
#line 394 "../src/sudoku-view.vala"
					break;
#line 3034 "sudoku-view.c"
				}
				{
					gint col = 0;
#line 395 "../src/sudoku-view.vala"
					col = 0;
#line 3040 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 395 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 395 "../src/sudoku-view.vala"
						while (TRUE) {
#line 3047 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							gboolean _tmp16_;
							gboolean _tmp17_;
#line 395 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 3058 "sudoku-view.c"
								gint _tmp9_;
#line 395 "../src/sudoku-view.vala"
								_tmp9_ = col;
#line 395 "../src/sudoku-view.vala"
								col = _tmp9_ + 1;
#line 3064 "sudoku-view.c"
							}
#line 395 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 395 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 395 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 395 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 395 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 395 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 395 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 395 "../src/sudoku-view.vala"
							if (!(col < _tmp15_)) {
#line 395 "../src/sudoku-view.vala"
								break;
#line 3084 "sudoku-view.c"
							}
#line 397 "../src/sudoku-view.vala"
							_tmp16_ = sudoku_view_get_show_possibilities (self);
#line 397 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_;
#line 397 "../src/sudoku-view.vala"
							if (_tmp17_) {
#line 3092 "sudoku-view.c"
								SudokuCell** _tmp18_;
								gint _tmp18__length1;
								gint _tmp18__length2;
								SudokuCell* _tmp19_;
								gboolean _tmp20_;
								gboolean _tmp21_;
#line 398 "../src/sudoku-view.vala"
								_tmp18_ = self->priv->cells;
#line 398 "../src/sudoku-view.vala"
								_tmp18__length1 = self->priv->cells_length1;
#line 398 "../src/sudoku-view.vala"
								_tmp18__length2 = self->priv->cells_length2;
#line 398 "../src/sudoku-view.vala"
								_tmp19_ = _tmp18_[(row * _tmp18__length2) + col];
#line 398 "../src/sudoku-view.vala"
								_tmp20_ = sudoku_view_get_show_possibilities (self);
#line 398 "../src/sudoku-view.vala"
								_tmp21_ = _tmp20_;
#line 398 "../src/sudoku-view.vala"
								sudoku_cell_initialize_earmarks (_tmp19_, _tmp21_, TRUE);
#line 3113 "sudoku-view.c"
							} else {
								SudokuGame* _tmp22_;
								SudokuGame* _tmp23_;
#line 400 "../src/sudoku-view.vala"
								_tmp22_ = sudoku_view_get_game (self);
#line 400 "../src/sudoku-view.vala"
								_tmp23_ = _tmp22_;
#line 400 "../src/sudoku-view.vala"
								sudoku_game_disable_all_earmarks (_tmp23_, row, col);
#line 3123 "sudoku-view.c"
							}
						}
					}
				}
			}
		}
	}
#line 392 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
#line 3133 "sudoku-view.c"
}

gboolean
sudoku_view_get_highlighter (SudokuView* self)
{
	gboolean result;
#line 409 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 409 "../src/sudoku-view.vala"
	result = self->priv->_highlighter;
#line 409 "../src/sudoku-view.vala"
	return result;
#line 3146 "sudoku-view.c"
}

void
sudoku_view_set_highlighter (SudokuView* self,
                             gboolean value)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 410 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 411 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->_selected_row;
#line 411 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->_selected_col;
#line 411 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp0_, _tmp1_, FALSE);
#line 412 "../src/sudoku-view.vala"
	self->priv->_highlighter = value;
#line 413 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->_selected_row;
#line 413 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->_selected_col;
#line 413 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp2_, _tmp3_, TRUE);
#line 410 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY]);
#line 3175 "sudoku-view.c"
}

gboolean
sudoku_view_get_has_selection (SudokuView* self)
{
	gboolean result;
#line 420 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 420 "../src/sudoku-view.vala"
	result = self->priv->_has_selection;
#line 420 "../src/sudoku-view.vala"
	return result;
#line 3188 "sudoku-view.c"
}

void
sudoku_view_set_has_selection (SudokuView* self,
                               gboolean value)
{
	SudokuCell* cell = NULL;
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint _tmp2_;
	SudokuCell* _tmp3_;
	SudokuCell* _tmp4_;
	SudokuCell* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gint _tmp12_;
	gint _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
#line 421 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 422 "../src/sudoku-view.vala"
	self->priv->_has_selection = value;
#line 423 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 423 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 423 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 423 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->_selected_row;
#line 423 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->_selected_col;
#line 423 "../src/sudoku-view.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 423 "../src/sudoku-view.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 423 "../src/sudoku-view.vala"
	cell = _tmp4_;
#line 424 "../src/sudoku-view.vala"
	_tmp5_ = cell;
#line 424 "../src/sudoku-view.vala"
	_tmp6_ = sudoku_view_get_has_selection (self);
#line 424 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_;
#line 424 "../src/sudoku-view.vala"
	sudoku_cell_set_selected (_tmp5_, _tmp7_);
#line 425 "../src/sudoku-view.vala"
	_tmp8_ = sudoku_view_get_has_selection (self);
#line 425 "../src/sudoku-view.vala"
	_tmp9_ = _tmp8_;
#line 425 "../src/sudoku-view.vala"
	if (_tmp9_) {
#line 3246 "sudoku-view.c"
		SudokuCell* _tmp10_;
#line 426 "../src/sudoku-view.vala"
		_tmp10_ = cell;
#line 426 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
#line 3252 "sudoku-view.c"
	} else {
		SudokuCell* _tmp11_;
#line 428 "../src/sudoku-view.vala"
		_tmp11_ = cell;
#line 428 "../src/sudoku-view.vala"
		sudoku_cell_dismiss_popover (_tmp11_);
#line 3259 "sudoku-view.c"
	}
#line 430 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->_selected_row;
#line 430 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->_selected_col;
#line 430 "../src/sudoku-view.vala"
	_tmp14_ = sudoku_view_get_has_selection (self);
#line 430 "../src/sudoku-view.vala"
	_tmp15_ = _tmp14_;
#line 430 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp12_, _tmp13_, _tmp15_);
#line 421 "../src/sudoku-view.vala"
	_g_object_unref0 (cell);
#line 421 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HAS_SELECTION_PROPERTY]);
#line 3275 "sudoku-view.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 26 "../src/sudoku-view.vala"
	g_return_if_fail (n_param_values == 5);
#line 26 "../src/sudoku-view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 26 "../src/sudoku-view.vala"
		data1 = closure->data;
#line 26 "../src/sudoku-view.vala"
		data2 = param_values->data[0].v_pointer;
#line 3300 "sudoku-view.c"
	} else {
#line 26 "../src/sudoku-view.vala"
		data1 = param_values->data[0].v_pointer;
#line 26 "../src/sudoku-view.vala"
		data2 = closure->data;
#line 3306 "sudoku-view.c"
	}
#line 26 "../src/sudoku-view.vala"
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 26 "../src/sudoku-view.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
#line 3312 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda14_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 180 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 181 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 181 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 183 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 183 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 183 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 183 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3340 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 183 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 183 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 183 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3350 "sudoku-view.c"
	}
#line 183 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 184 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 184 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 184 "../src/sudoku-view.vala"
		return result;
#line 3360 "sudoku-view.c"
	}
#line 186 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 186 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_row;
#line 186 "../src/sudoku-view.vala"
	if (_tmp7_ == 0) {
#line 3368 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 187 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 187 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 187 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 187 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 187 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 187 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_col;
#line 187 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(8 * _tmp9__length2) + _tmp11_];
#line 187 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3392 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 189 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 189 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 189 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 189 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 189 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 189 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 189 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 189 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 189 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[((_tmp16_ - 1) * _tmp14__length2) + _tmp18_];
#line 189 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3423 "sudoku-view.c"
	}
#line 191 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 191 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 191 "../src/sudoku-view.vala"
	return result;
#line 3431 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda14__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda14_ (widget);
#line 180 "../src/sudoku-view.vala"
	return result;
#line 3443 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda15_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 193 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 194 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 194 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 196 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 196 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 196 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 196 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3471 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 196 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 196 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 196 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3481 "sudoku-view.c"
	}
#line 196 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 197 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 197 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 197 "../src/sudoku-view.vala"
		return result;
#line 3491 "sudoku-view.c"
	}
#line 199 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 199 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_row;
#line 199 "../src/sudoku-view.vala"
	if (_tmp7_ == 8) {
#line 3499 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 200 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 200 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 200 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 200 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 200 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 200 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_col;
#line 200 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(0 * _tmp9__length2) + _tmp11_];
#line 200 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3523 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 202 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 202 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 202 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 202 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 202 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 202 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 202 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 202 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 202 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[((_tmp16_ + 1) * _tmp14__length2) + _tmp18_];
#line 202 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3554 "sudoku-view.c"
	}
#line 204 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 204 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 204 "../src/sudoku-view.vala"
	return result;
#line 3562 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda15__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda15_ (widget);
#line 193 "../src/sudoku-view.vala"
	return result;
#line 3574 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda16_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 206 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 207 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 207 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 209 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 209 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 209 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 209 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3602 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 209 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 209 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 209 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3612 "sudoku-view.c"
	}
#line 209 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 210 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 210 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 210 "../src/sudoku-view.vala"
		return result;
#line 3622 "sudoku-view.c"
	}
#line 212 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 212 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_col;
#line 212 "../src/sudoku-view.vala"
	if (_tmp7_ == 0) {
#line 3630 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 213 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 213 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 213 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 213 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 213 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 213 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_row;
#line 213 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(_tmp11_ * _tmp9__length2) + 8];
#line 213 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3654 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 215 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 215 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 215 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 215 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 215 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 215 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 215 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 215 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 215 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[(_tmp16_ * _tmp14__length2) + (_tmp18_ - 1)];
#line 215 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3685 "sudoku-view.c"
	}
#line 217 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 217 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 217 "../src/sudoku-view.vala"
	return result;
#line 3693 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda16__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda16_ (widget);
#line 206 "../src/sudoku-view.vala"
	return result;
#line 3705 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda17_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 219 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 220 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 220 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 222 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 222 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 222 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 222 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3733 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 222 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 222 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 222 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3743 "sudoku-view.c"
	}
#line 222 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 223 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 223 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 223 "../src/sudoku-view.vala"
		return result;
#line 3753 "sudoku-view.c"
	}
#line 225 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 225 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_col;
#line 225 "../src/sudoku-view.vala"
	if (_tmp7_ == 8) {
#line 3761 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 226 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 226 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 226 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 226 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 226 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 226 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_row;
#line 226 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(_tmp11_ * _tmp9__length2) + 0];
#line 226 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3785 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 228 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 228 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 228 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 228 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 228 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 228 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 228 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 228 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 228 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[(_tmp16_ * _tmp14__length2) + (_tmp18_ + 1)];
#line 228 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3816 "sudoku-view.c"
	}
#line 230 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 230 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 230 "../src/sudoku-view.vala"
	return result;
#line 3824 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda17__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda17_ (widget);
#line 219 "../src/sudoku-view.vala"
	return result;
#line 3836 "sudoku-view.c"
}

static void
sudoku_view_class_init (SudokuViewClass * klass,
                        gpointer klass_data)
{
	GtkShortcutFunc up_func = NULL;
	gpointer up_func_target;
	GDestroyNotify up_func_target_destroy_notify;
	GtkShortcutFunc down_func = NULL;
	gpointer down_func_target;
	GDestroyNotify down_func_target_destroy_notify;
	GtkShortcutFunc left_func = NULL;
	gpointer left_func_target;
	GDestroyNotify left_func_target_destroy_notify;
	GtkShortcutFunc right_func = NULL;
	gpointer right_func_target;
	GDestroyNotify right_func_target_destroy_notify;
	GtkShortcutFunc _tmp0_;
	gpointer _tmp0__target;
	GtkShortcutFunc _tmp1_;
	gpointer _tmp1__target;
	GtkShortcutFunc _tmp2_;
	gpointer _tmp2__target;
	GtkShortcutFunc _tmp3_;
	gpointer _tmp3__target;
	GtkShortcutFunc _tmp4_;
	gpointer _tmp4__target;
	GtkShortcutFunc _tmp5_;
	gpointer _tmp5__target;
	GtkShortcutFunc _tmp6_;
	gpointer _tmp6__target;
	GtkShortcutFunc _tmp7_;
	gpointer _tmp7__target;
	GtkShortcutFunc _tmp8_;
	gpointer _tmp8__target;
	GtkShortcutFunc _tmp9_;
	gpointer _tmp9__target;
	GtkShortcutFunc _tmp10_;
	gpointer _tmp10__target;
	GtkShortcutFunc _tmp11_;
	gpointer _tmp11__target;
#line 26 "../src/sudoku-view.vala"
	sudoku_view_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/sudoku-view.vala"
	g_type_class_adjust_private_offset (klass, &SudokuView_private_offset);
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_view_get_property;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_view_set_property;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_view_finalize;
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_GAME_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_SUDOKU_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_ROW_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY] = g_param_spec_int ("selected-row", "selected-row", "selected-row", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_COL_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY] = g_param_spec_int ("selected-col", "selected-col", "selected-col", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-extra-warnings", "show-extra-warnings", "show-extra-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHTER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY] = g_param_spec_boolean ("highlighter", "highlighter", "highlighter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HAS_SELECTION_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HAS_SELECTION_PROPERTY] = g_param_spec_boolean ("has-selection", "has-selection", "has-selection", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	sudoku_view_signals[SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", TYPE_SUDOKU_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
#line 180 "../src/sudoku-view.vala"
	up_func = __sudoku_view___lambda14__gtk_shortcut_func;
#line 180 "../src/sudoku-view.vala"
	up_func_target = NULL;
#line 180 "../src/sudoku-view.vala"
	up_func_target_destroy_notify = NULL;
#line 193 "../src/sudoku-view.vala"
	down_func = __sudoku_view___lambda15__gtk_shortcut_func;
#line 193 "../src/sudoku-view.vala"
	down_func_target = NULL;
#line 193 "../src/sudoku-view.vala"
	down_func_target_destroy_notify = NULL;
#line 206 "../src/sudoku-view.vala"
	left_func = __sudoku_view___lambda16__gtk_shortcut_func;
#line 206 "../src/sudoku-view.vala"
	left_func_target = NULL;
#line 206 "../src/sudoku-view.vala"
	left_func_target_destroy_notify = NULL;
#line 219 "../src/sudoku-view.vala"
	right_func = __sudoku_view___lambda17__gtk_shortcut_func;
#line 219 "../src/sudoku-view.vala"
	right_func_target = NULL;
#line 219 "../src/sudoku-view.vala"
	right_func_target_destroy_notify = NULL;
#line 233 "../src/sudoku-view.vala"
	_tmp0_ = up_func;
#line 233 "../src/sudoku-view.vala"
	_tmp0__target = up_func_target;
#line 233 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Up, 0, _tmp0_, _tmp0__target, NULL, NULL);
#line 234 "../src/sudoku-view.vala"
	_tmp1_ = up_func;
#line 234 "../src/sudoku-view.vala"
	_tmp1__target = up_func_target;
#line 234 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Up, 0, _tmp1_, _tmp1__target, NULL, NULL);
#line 235 "../src/sudoku-view.vala"
	_tmp2_ = up_func;
#line 235 "../src/sudoku-view.vala"
	_tmp2__target = up_func_target;
#line 235 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_w, 0, _tmp2_, _tmp2__target, NULL, NULL);
#line 236 "../src/sudoku-view.vala"
	_tmp3_ = down_func;
#line 236 "../src/sudoku-view.vala"
	_tmp3__target = down_func_target;
#line 236 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Down, 0, _tmp3_, _tmp3__target, NULL, NULL);
#line 237 "../src/sudoku-view.vala"
	_tmp4_ = down_func;
#line 237 "../src/sudoku-view.vala"
	_tmp4__target = down_func_target;
#line 237 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Down, 0, _tmp4_, _tmp4__target, NULL, NULL);
#line 238 "../src/sudoku-view.vala"
	_tmp5_ = down_func;
#line 238 "../src/sudoku-view.vala"
	_tmp5__target = down_func_target;
#line 238 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_s, 0, _tmp5_, _tmp5__target, NULL, NULL);
#line 239 "../src/sudoku-view.vala"
	_tmp6_ = left_func;
#line 239 "../src/sudoku-view.vala"
	_tmp6__target = left_func_target;
#line 239 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Left, 0, _tmp6_, _tmp6__target, NULL, NULL);
#line 240 "../src/sudoku-view.vala"
	_tmp7_ = left_func;
#line 240 "../src/sudoku-view.vala"
	_tmp7__target = left_func_target;
#line 240 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Left, 0, _tmp7_, _tmp7__target, NULL, NULL);
#line 241 "../src/sudoku-view.vala"
	_tmp8_ = left_func;
#line 241 "../src/sudoku-view.vala"
	_tmp8__target = left_func_target;
#line 241 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_a, 0, _tmp8_, _tmp8__target, NULL, NULL);
#line 242 "../src/sudoku-view.vala"
	_tmp9_ = right_func;
#line 242 "../src/sudoku-view.vala"
	_tmp9__target = right_func_target;
#line 242 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Right, 0, _tmp9_, _tmp9__target, NULL, NULL);
#line 243 "../src/sudoku-view.vala"
	_tmp10_ = right_func;
#line 243 "../src/sudoku-view.vala"
	_tmp10__target = right_func_target;
#line 243 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Right, 0, _tmp10_, _tmp10__target, NULL, NULL);
#line 244 "../src/sudoku-view.vala"
	_tmp11_ = right_func;
#line 244 "../src/sudoku-view.vala"
	_tmp11__target = right_func_target;
#line 244 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_d, 0, _tmp11_, _tmp11__target, NULL, NULL);
#line 179 "../src/sudoku-view.vala"
	(right_func_target_destroy_notify == NULL) ? NULL : (right_func_target_destroy_notify (right_func_target), NULL);
#line 179 "../src/sudoku-view.vala"
	right_func = NULL;
#line 179 "../src/sudoku-view.vala"
	right_func_target = NULL;
#line 179 "../src/sudoku-view.vala"
	right_func_target_destroy_notify = NULL;
#line 179 "../src/sudoku-view.vala"
	(left_func_target_destroy_notify == NULL) ? NULL : (left_func_target_destroy_notify (left_func_target), NULL);
#line 179 "../src/sudoku-view.vala"
	left_func = NULL;
#line 179 "../src/sudoku-view.vala"
	left_func_target = NULL;
#line 179 "../src/sudoku-view.vala"
	left_func_target_destroy_notify = NULL;
#line 179 "../src/sudoku-view.vala"
	(down_func_target_destroy_notify == NULL) ? NULL : (down_func_target_destroy_notify (down_func_target), NULL);
#line 179 "../src/sudoku-view.vala"
	down_func = NULL;
#line 179 "../src/sudoku-view.vala"
	down_func_target = NULL;
#line 179 "../src/sudoku-view.vala"
	down_func_target_destroy_notify = NULL;
#line 179 "../src/sudoku-view.vala"
	(up_func_target_destroy_notify == NULL) ? NULL : (up_func_target_destroy_notify (up_func_target), NULL);
#line 179 "../src/sudoku-view.vala"
	up_func = NULL;
#line 179 "../src/sudoku-view.vala"
	up_func_target = NULL;
#line 179 "../src/sudoku-view.vala"
	up_func_target_destroy_notify = NULL;
#line 4035 "sudoku-view.c"
}

static void
sudoku_view_instance_init (SudokuView * self,
                           gpointer klass)
{
#line 26 "../src/sudoku-view.vala"
	self->priv = sudoku_view_get_instance_private (self);
#line 41 "../src/sudoku-view.vala"
	self->priv->_selected_row = 0;
#line 42 "../src/sudoku-view.vala"
	self->priv->_selected_col = 0;
#line 417 "../src/sudoku-view.vala"
	self->priv->_has_selection = TRUE;
#line 4050 "sudoku-view.c"
}

static void
sudoku_view_finalize (GObject * obj)
{
	SudokuView * self;
#line 26 "../src/sudoku-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_VIEW, SudokuView);
#line 28 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 35 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 36 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->paused);
#line 38 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->overlay);
#line 39 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->grid);
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->finalize (obj);
#line 4071 "sudoku-view.c"
}

static GType
sudoku_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuView), 0, (GInstanceInitFunc) sudoku_view_instance_init, NULL };
	GType sudoku_view_type_id;
	sudoku_view_type_id = g_type_register_static (adw_bin_get_type (), "SudokuView", &g_define_type_info, 0);
	SudokuView_private_offset = g_type_add_instance_private (sudoku_view_type_id, sizeof (SudokuViewPrivate));
	return sudoku_view_type_id;
}

GType
sudoku_view_get_type (void)
{
	static volatile gsize sudoku_view_type_id__once = 0;
	if (g_once_init_enter (&sudoku_view_type_id__once)) {
		GType sudoku_view_type_id;
		sudoku_view_type_id = sudoku_view_get_type_once ();
		g_once_init_leave (&sudoku_view_type_id__once, sudoku_view_type_id);
	}
	return sudoku_view_type_id__once;
}

static void
_vala_sudoku_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/sudoku-view.vala"
	switch (property_id) {
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_GAME_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_object (value, sudoku_view_get_game (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_int (value, sudoku_view_get_selected_row (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_int (value, sudoku_view_get_selected_col (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_extra_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_possibilities (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_highlighter (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HAS_SELECTION_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_has_selection (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 4154 "sudoku-view.c"
		default:
#line 26 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-view.vala"
		break;
#line 4160 "sudoku-view.c"
	}
}

static void
_vala_sudoku_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/sudoku-view.vala"
	switch (property_id) {
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_GAME_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_game (self, g_value_get_object (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_selected_row (self, g_value_get_int (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_selected_col (self, g_value_get_int (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_extra_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_possibilities (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_highlighter (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HAS_SELECTION_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_has_selection (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 4222 "sudoku-view.c"
		default:
#line 26 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-view.vala"
		break;
#line 4228 "sudoku-view.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

