/* sudoku-window.c generated by valac 0.56.16, the Vala compiler
 * generated from sudoku-window.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014, 2020 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gio/gio.h>
#include "libsudoku.h"
#include <float.h>
#include <math.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <gdk/gdk.h>

#define SUDOKU_WINDOW_board_size 140
#define SUDOKU_WINDOW_clock_in_headerbar_min_width 450
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_WINDOW (sudoku_window_get_type ())
#define SUDOKU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_WINDOW, SudokuWindow))
#define SUDOKU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_WINDOW, SudokuWindowClass))
#define IS_SUDOKU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_WINDOW))
#define IS_SUDOKU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_WINDOW))
#define SUDOKU_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_WINDOW, SudokuWindowClass))

typedef struct _SudokuWindow SudokuWindow;
typedef struct _SudokuWindowClass SudokuWindowClass;
typedef struct _SudokuWindowPrivate SudokuWindowPrivate;

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
enum  {
	SUDOKU_WINDOW_0_PROPERTY,
	SUDOKU_WINDOW_VIEW_PROPERTY,
	SUDOKU_WINDOW_SHOW_TIMER_PROPERTY,
	SUDOKU_WINDOW_NUM_PROPERTIES
};
static GParamSpec* sudoku_window_properties[SUDOKU_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuWindow {
	AdwApplicationWindow parent_instance;
	SudokuWindowPrivate * priv;
};

struct _SudokuWindowClass {
	AdwApplicationWindowClass parent_class;
};

struct _SudokuWindowPrivate {
	AdwHeaderBar* headerbar;
	AdwWindowTitle* windowtitle;
	GtkBox* start_box;
	GtkButton* start_button;
	GtkCheckButton* easy_check;
	GtkCheckButton* medium_check;
	GtkCheckButton* hard_check;
	GtkCheckButton* very_hard_check;
	GtkBox* game_box;
	GtkMenuButton* main_menu;
	GtkButton* undo_button;
	GtkButton* redo_button;
	GtkButton* back_button;
	GtkBox* clock_box;
	GtkLabel* clock_label;
	GtkImage* clock_image;
	GtkButton* play_custom_game_button;
	GtkButton* play_pause_button;
	gboolean window_is_maximized;
	gboolean window_is_fullscreen;
	gint window_width;
	gint window_height;
	gboolean clock_in_headerbar;
	GSettings* settings;
	SudokuView* _view;
	SudokuGame* game;
	GtkGestureClick* button_controller;
	GtkGestureLongPress* long_press_controller;
	gboolean _show_timer;
};

static gint SudokuWindow_private_offset;
static gpointer sudoku_window_parent_class = NULL;

VALA_EXTERN GType sudoku_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuWindow, g_object_unref)
VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN gboolean sudoku_window_get_show_timer (SudokuWindow* self);
VALA_EXTERN SudokuWindow* sudoku_window_new (GSettings* settings);
VALA_EXTERN SudokuWindow* sudoku_window_construct (GType object_type,
                                       GSettings* settings);
VALA_EXTERN void sudoku_window_set_show_timer (SudokuWindow* self,
                                   gboolean value);
static void __lambda18_ (SudokuWindow* self);
static void ___lambda18__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda19_ (SudokuWindow* self);
static void ___lambda19__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda20_ (SudokuWindow* self);
VALA_EXTERN SudokuView* sudoku_window_get_view (SudokuWindow* self);
VALA_EXTERN void sudoku_view_set_has_selection (SudokuView* self,
                                    gboolean value);
static void ___lambda20__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void sudoku_window_button_released_cb (SudokuWindow* self,
                                       GtkGestureClick* gesture,
                                       gint n_press,
                                       gdouble x,
                                       gdouble y);
static void _sudoku_window_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                   gint n_press,
                                                                   gdouble x,
                                                                   gdouble y,
                                                                   gpointer self);
static void sudoku_window_long_press_cb (SudokuWindow* self,
                                  GtkGestureLongPress* gesture,
                                  gdouble x,
                                  gdouble y);
static void _sudoku_window_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                                  gdouble x,
                                                                  gdouble y,
                                                                  gpointer self);
static void sudoku_window_real_size_allocate (GtkWidget* base,
                                       gint width,
                                       gint height,
                                       gint baseline);
static void sudoku_window_set_clock_placed_in_headerbar (SudokuWindow* self,
                                                  gboolean value);
static void sudoku_window_start_game_cb (SudokuWindow* self,
                                  GtkButton* btn);
static gboolean* _bool_dup (gboolean* self);
static void _sudoku_window_start_game_cb_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self);
VALA_EXTERN void sudoku_window_will_start_game (SudokuWindow* self);
VALA_EXTERN void sudoku_window_start_game (SudokuWindow* self,
                               SudokuGame* game);
static void sudoku_window_tick_cb (SudokuWindow* self);
static void _sudoku_window_tick_cb_sudoku_game_tick (SudokuGame* _sender,
                                              gpointer self);
VALA_EXTERN void sudoku_window_show_game_view (SudokuWindow* self);
VALA_EXTERN SudokuView* sudoku_view_new (SudokuGame* game,
                             GSettings* settings);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   SudokuGame* game,
                                   GSettings* settings);
static void sudoku_window_set_view (SudokuWindow* self,
                             SudokuView* value);
VALA_EXTERN void sudoku_window_show_new_game_screen (SudokuWindow* self);
VALA_EXTERN void sudoku_window_set_board_visible (SudokuWindow* self,
                                      gboolean visible);
VALA_EXTERN void sudoku_window_activate_difficulty_checkbutton (SudokuWindow* self,
                                                    DifficultyCategory difficulty);
VALA_EXTERN void sudoku_window_display_pause_button (SudokuWindow* self);
VALA_EXTERN gboolean sudoku_window_is_board_visible (SudokuWindow* self);
VALA_EXTERN void sudoku_window_set_headerbar_title (SudokuWindow* self);
VALA_EXTERN void sudoku_window_board_completed (SudokuWindow* self);
VALA_EXTERN void sudoku_view_dismiss_popovers (SudokuView* self);
static void sudoku_window_finalize (GObject * obj);
static GType sudoku_window_get_type_once (void);
static void _vala_sudoku_window_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_sudoku_window_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static inline gpointer
sudoku_window_get_instance_private (SudokuWindow* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuWindow_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 73 "../src/sudoku-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 237 "sudoku-window.c"
}

static void
__lambda18_ (SudokuWindow* self)
{
#line 81 "../src/sudoku-window.vala"
	self->priv->window_is_maximized = !self->priv->window_is_maximized;
#line 245 "sudoku-window.c"
}

static void
___lambda18__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 80 "../src/sudoku-window.vala"
	__lambda18_ ((SudokuWindow*) self);
#line 255 "sudoku-window.c"
}

static void
__lambda19_ (SudokuWindow* self)
{
#line 85 "../src/sudoku-window.vala"
	self->priv->window_is_fullscreen = !self->priv->window_is_fullscreen;
#line 263 "sudoku-window.c"
}

static void
___lambda19__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 84 "../src/sudoku-window.vala"
	__lambda19_ ((SudokuWindow*) self);
#line 273 "sudoku-window.c"
}

static void
__lambda20_ (SudokuWindow* self)
{
	SudokuView* _tmp0_;
#line 89 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->_view;
#line 89 "../src/sudoku-window.vala"
	if (_tmp0_ != NULL) {
#line 284 "sudoku-window.c"
		SudokuView* _tmp1_;
		GtkMenuButton* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 90 "../src/sudoku-window.vala"
		_tmp1_ = self->priv->_view;
#line 90 "../src/sudoku-window.vala"
		_tmp2_ = self->priv->main_menu;
#line 90 "../src/sudoku-window.vala"
		_tmp3_ = gtk_menu_button_get_active (_tmp2_);
#line 90 "../src/sudoku-window.vala"
		_tmp4_ = _tmp3_;
#line 90 "../src/sudoku-window.vala"
		sudoku_view_set_has_selection (_tmp1_, !_tmp4_);
#line 299 "sudoku-window.c"
	}
}

static void
___lambda20__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 88 "../src/sudoku-window.vala"
	__lambda20_ ((SudokuWindow*) self);
#line 310 "sudoku-window.c"
}

static void
_sudoku_window_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                              gint n_press,
                                                              gdouble x,
                                                              gdouble y,
                                                              gpointer self)
{
#line 94 "../src/sudoku-window.vala"
	sudoku_window_button_released_cb ((SudokuWindow*) self, _sender, n_press, x, y);
#line 322 "sudoku-window.c"
}

static void
_sudoku_window_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                             gdouble x,
                                                             gdouble y,
                                                             gpointer self)
{
#line 97 "../src/sudoku-window.vala"
	sudoku_window_long_press_cb ((SudokuWindow*) self, _sender, x, y);
#line 333 "sudoku-window.c"
}

SudokuWindow*
sudoku_window_construct (GType object_type,
                         GSettings* settings)
{
	SudokuWindow * self = NULL;
	GSettings* _tmp0_;
	GtkMenuButton* _tmp1_;
	GtkGestureClick* _tmp2_;
	GtkGestureClick* _tmp3_;
	GtkGestureClick* _tmp4_;
	GtkEventController* _tmp5_;
	GtkGestureLongPress* _tmp6_;
	GtkGestureLongPress* _tmp7_;
	GtkEventController* _tmp8_;
#line 71 "../src/sudoku-window.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 71 "../src/sudoku-window.vala"
	self = (SudokuWindow*) g_object_new (object_type, NULL);
#line 73 "../src/sudoku-window.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 73 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->settings);
#line 73 "../src/sudoku-window.vala"
	self->priv->settings = _tmp0_;
#line 74 "../src/sudoku-window.vala"
	sudoku_window_set_show_timer (self, g_settings_get_boolean (settings, "show-timer"));
#line 76 "../src/sudoku-window.vala"
	gtk_window_set_default_size ((GtkWindow*) self, g_settings_get_int (settings, "window-width"), g_settings_get_int (settings, "window-height"));
#line 77 "../src/sudoku-window.vala"
	if (g_settings_get_boolean (settings, "window-is-maximized")) {
#line 78 "../src/sudoku-window.vala"
		gtk_window_maximize ((GtkWindow*) self);
#line 368 "sudoku-window.c"
	}
#line 80 "../src/sudoku-window.vala"
	g_signal_connect_object ((GObject*) self, "notify::maximized", (GCallback) ___lambda18__g_object_notify, self, 0);
#line 84 "../src/sudoku-window.vala"
	g_signal_connect_object ((GObject*) self, "notify::fullscreened", (GCallback) ___lambda19__g_object_notify, self, 0);
#line 88 "../src/sudoku-window.vala"
	_tmp1_ = self->priv->main_menu;
#line 88 "../src/sudoku-window.vala"
	g_signal_connect_object ((GObject*) _tmp1_, "notify::active", (GCallback) ___lambda20__g_object_notify, self, 0);
#line 93 "../src/sudoku-window.vala"
	_tmp2_ = self->priv->button_controller;
#line 93 "../src/sudoku-window.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp2_, (guint) 0);
#line 94 "../src/sudoku-window.vala"
	_tmp3_ = self->priv->button_controller;
#line 94 "../src/sudoku-window.vala"
	g_signal_connect_object (_tmp3_, "released", (GCallback) _sudoku_window_button_released_cb_gtk_gesture_click_released, self, 0);
#line 95 "../src/sudoku-window.vala"
	_tmp4_ = self->priv->button_controller;
#line 95 "../src/sudoku-window.vala"
	_tmp5_ = _g_object_ref0 ((GtkEventController*) _tmp4_);
#line 95 "../src/sudoku-window.vala"
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp5_);
#line 97 "../src/sudoku-window.vala"
	_tmp6_ = self->priv->long_press_controller;
#line 97 "../src/sudoku-window.vala"
	g_signal_connect_object (_tmp6_, "pressed", (GCallback) _sudoku_window_long_press_cb_gtk_gesture_long_press_pressed, self, 0);
#line 98 "../src/sudoku-window.vala"
	_tmp7_ = self->priv->long_press_controller;
#line 98 "../src/sudoku-window.vala"
	_tmp8_ = _g_object_ref0 ((GtkEventController*) _tmp7_);
#line 98 "../src/sudoku-window.vala"
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp8_);
#line 71 "../src/sudoku-window.vala"
	return self;
#line 404 "sudoku-window.c"
}

SudokuWindow*
sudoku_window_new (GSettings* settings)
{
#line 71 "../src/sudoku-window.vala"
	return sudoku_window_construct (TYPE_SUDOKU_WINDOW, settings);
#line 412 "sudoku-window.c"
}

static void
sudoku_window_real_size_allocate (GtkWidget* base,
                                  gint width,
                                  gint height,
                                  gint baseline)
{
	SudokuWindow * self;
	gboolean _tmp0_ = FALSE;
#line 112 "../src/sudoku-window.vala"
	self = (SudokuWindow*) base;
#line 114 "../src/sudoku-window.vala"
	GTK_WIDGET_CLASS (sudoku_window_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_window_get_type (), AdwApplicationWindow), width, height, baseline);
#line 116 "../src/sudoku-window.vala"
	sudoku_window_set_clock_placed_in_headerbar (self, width > SUDOKU_WINDOW_clock_in_headerbar_min_width);
#line 118 "../src/sudoku-window.vala"
	if (self->priv->window_is_maximized) {
#line 118 "../src/sudoku-window.vala"
		_tmp0_ = TRUE;
#line 433 "sudoku-window.c"
	} else {
#line 118 "../src/sudoku-window.vala"
		_tmp0_ = self->priv->window_is_fullscreen;
#line 437 "sudoku-window.c"
	}
#line 118 "../src/sudoku-window.vala"
	if (_tmp0_) {
#line 119 "../src/sudoku-window.vala"
		return;
#line 443 "sudoku-window.c"
	}
#line 121 "../src/sudoku-window.vala"
	self->priv->window_width = width;
#line 122 "../src/sudoku-window.vala"
	self->priv->window_height = height;
#line 449 "sudoku-window.c"
}

static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
#line 129 "../src/sudoku-window.vala"
	dup = g_new0 (gboolean, 1);
#line 129 "../src/sudoku-window.vala"
	memcpy (dup, self, sizeof (gboolean));
#line 129 "../src/sudoku-window.vala"
	return dup;
#line 462 "sudoku-window.c"
}

static gpointer
__bool_dup0 (gpointer self)
{
#line 129 "../src/sudoku-window.vala"
	return self ? _bool_dup (self) : NULL;
#line 470 "sudoku-window.c"
}

static void
sudoku_window_start_game_cb (SudokuWindow* self,
                             GtkButton* btn)
{
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 126 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 126 "../src/sudoku-window.vala"
	g_return_if_fail (btn != NULL);
#line 128 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->easy_check;
#line 128 "../src/sudoku-window.vala"
	_tmp1_ = gtk_check_button_get_active (_tmp0_);
#line 128 "../src/sudoku-window.vala"
	_tmp2_ = _tmp1_;
#line 128 "../src/sudoku-window.vala"
	if (_tmp2_) {
#line 492 "sudoku-window.c"
		GtkWidget* _tmp3_ = NULL;
		gboolean* _tmp4_ = NULL;
#line 129 "../src/sudoku-window.vala"
		_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 129 "../src/sudoku-window.vala"
		_tmp4_ = NULL;
#line 129 "../src/sudoku-window.vala"
		if (_tmp3_ != NULL) {
#line 501 "sudoku-window.c"
			gboolean _tmp5_;
			gboolean* _tmp6_;
#line 129 "../src/sudoku-window.vala"
			_tmp5_ = gtk_widget_activate_action (_tmp3_, "app.start-game", "i", 1, NULL);
#line 129 "../src/sudoku-window.vala"
			_tmp6_ = __bool_dup0 (&_tmp5_);
#line 129 "../src/sudoku-window.vala"
			_g_free0 (_tmp4_);
#line 129 "../src/sudoku-window.vala"
			_tmp4_ = _tmp6_;
#line 512 "sudoku-window.c"
		}
#line 128 "../src/sudoku-window.vala"
		_g_free0 (_tmp4_);
#line 516 "sudoku-window.c"
	} else {
		GtkCheckButton* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 130 "../src/sudoku-window.vala"
		_tmp7_ = self->priv->medium_check;
#line 130 "../src/sudoku-window.vala"
		_tmp8_ = gtk_check_button_get_active (_tmp7_);
#line 130 "../src/sudoku-window.vala"
		_tmp9_ = _tmp8_;
#line 130 "../src/sudoku-window.vala"
		if (_tmp9_) {
#line 529 "sudoku-window.c"
			GtkWidget* _tmp10_ = NULL;
			gboolean* _tmp11_ = NULL;
#line 131 "../src/sudoku-window.vala"
			_tmp10_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 131 "../src/sudoku-window.vala"
			_tmp11_ = NULL;
#line 131 "../src/sudoku-window.vala"
			if (_tmp10_ != NULL) {
#line 538 "sudoku-window.c"
				gboolean _tmp12_;
				gboolean* _tmp13_;
#line 131 "../src/sudoku-window.vala"
				_tmp12_ = gtk_widget_activate_action (_tmp10_, "app.start-game", "i", 2, NULL);
#line 131 "../src/sudoku-window.vala"
				_tmp13_ = __bool_dup0 (&_tmp12_);
#line 131 "../src/sudoku-window.vala"
				_g_free0 (_tmp11_);
#line 131 "../src/sudoku-window.vala"
				_tmp11_ = _tmp13_;
#line 549 "sudoku-window.c"
			}
#line 130 "../src/sudoku-window.vala"
			_g_free0 (_tmp11_);
#line 553 "sudoku-window.c"
		} else {
			GtkCheckButton* _tmp14_;
			gboolean _tmp15_;
			gboolean _tmp16_;
#line 132 "../src/sudoku-window.vala"
			_tmp14_ = self->priv->hard_check;
#line 132 "../src/sudoku-window.vala"
			_tmp15_ = gtk_check_button_get_active (_tmp14_);
#line 132 "../src/sudoku-window.vala"
			_tmp16_ = _tmp15_;
#line 132 "../src/sudoku-window.vala"
			if (_tmp16_) {
#line 566 "sudoku-window.c"
				GtkWidget* _tmp17_ = NULL;
				gboolean* _tmp18_ = NULL;
#line 133 "../src/sudoku-window.vala"
				_tmp17_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 133 "../src/sudoku-window.vala"
				_tmp18_ = NULL;
#line 133 "../src/sudoku-window.vala"
				if (_tmp17_ != NULL) {
#line 575 "sudoku-window.c"
					gboolean _tmp19_;
					gboolean* _tmp20_;
#line 133 "../src/sudoku-window.vala"
					_tmp19_ = gtk_widget_activate_action (_tmp17_, "app.start-game", "i", 3, NULL);
#line 133 "../src/sudoku-window.vala"
					_tmp20_ = __bool_dup0 (&_tmp19_);
#line 133 "../src/sudoku-window.vala"
					_g_free0 (_tmp18_);
#line 133 "../src/sudoku-window.vala"
					_tmp18_ = _tmp20_;
#line 586 "sudoku-window.c"
				}
#line 132 "../src/sudoku-window.vala"
				_g_free0 (_tmp18_);
#line 590 "sudoku-window.c"
			} else {
				GtkCheckButton* _tmp21_;
				gboolean _tmp22_;
				gboolean _tmp23_;
#line 134 "../src/sudoku-window.vala"
				_tmp21_ = self->priv->very_hard_check;
#line 134 "../src/sudoku-window.vala"
				_tmp22_ = gtk_check_button_get_active (_tmp21_);
#line 134 "../src/sudoku-window.vala"
				_tmp23_ = _tmp22_;
#line 134 "../src/sudoku-window.vala"
				if (_tmp23_) {
#line 603 "sudoku-window.c"
					GtkWidget* _tmp24_ = NULL;
					gboolean* _tmp25_ = NULL;
#line 135 "../src/sudoku-window.vala"
					_tmp24_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 135 "../src/sudoku-window.vala"
					_tmp25_ = NULL;
#line 135 "../src/sudoku-window.vala"
					if (_tmp24_ != NULL) {
#line 612 "sudoku-window.c"
						gboolean _tmp26_;
						gboolean* _tmp27_;
#line 135 "../src/sudoku-window.vala"
						_tmp26_ = gtk_widget_activate_action (_tmp24_, "app.start-game", "i", 4, NULL);
#line 135 "../src/sudoku-window.vala"
						_tmp27_ = __bool_dup0 (&_tmp26_);
#line 135 "../src/sudoku-window.vala"
						_g_free0 (_tmp25_);
#line 135 "../src/sudoku-window.vala"
						_tmp25_ = _tmp27_;
#line 623 "sudoku-window.c"
					}
#line 134 "../src/sudoku-window.vala"
					_g_free0 (_tmp25_);
#line 627 "sudoku-window.c"
				}
			}
		}
	}
}

static void
_sudoku_window_start_game_cb_gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self)
{
#line 26 "../src/sudoku-window.vala"
	sudoku_window_start_game_cb ((SudokuWindow*) self, _sender);
#line 640 "sudoku-window.c"
}

void
sudoku_window_will_start_game (SudokuWindow* self)
{
	GtkButton* _tmp0_;
#line 156 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->back_button;
#line 158 "../src/sudoku-window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
#line 653 "sudoku-window.c"
}

static void
_sudoku_window_tick_cb_sudoku_game_tick (SudokuGame* _sender,
                                         gpointer self)
{
#line 164 "../src/sudoku-window.vala"
	sudoku_window_tick_cb ((SudokuWindow*) self);
#line 662 "sudoku-window.c"
}

void
sudoku_window_start_game (SudokuWindow* self,
                          SudokuGame* game)
{
	SudokuGame* _tmp0_;
	SudokuGame* _tmp3_;
	SudokuView* _tmp4_;
	GSettings* _tmp7_;
	SudokuView* _tmp8_;
	SudokuView* _tmp9_;
	SudokuView* _tmp10_;
	GtkBox* _tmp11_;
	SudokuView* _tmp12_;
	SudokuView* _tmp13_;
	GtkButton* _tmp14_;
#line 161 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 161 "../src/sudoku-window.vala"
	g_return_if_fail (game != NULL);
#line 163 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->game;
#line 163 "../src/sudoku-window.vala"
	if (_tmp0_ != NULL) {
#line 688 "sudoku-window.c"
		SudokuGame* _tmp1_;
		guint _tmp2_;
#line 164 "../src/sudoku-window.vala"
		_tmp1_ = self->priv->game;
#line 164 "../src/sudoku-window.vala"
		g_signal_parse_name ("tick", TYPE_SUDOKU_GAME, &_tmp2_, NULL, FALSE);
#line 164 "../src/sudoku-window.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _sudoku_window_tick_cb_sudoku_game_tick, self);
#line 697 "sudoku-window.c"
	}
#line 165 "../src/sudoku-window.vala"
	_tmp3_ = _g_object_ref0 (game);
#line 165 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->game);
#line 165 "../src/sudoku-window.vala"
	self->priv->game = _tmp3_;
#line 166 "../src/sudoku-window.vala"
	g_signal_connect_object (game, "tick", (GCallback) _sudoku_window_tick_cb_sudoku_game_tick, self, 0);
#line 167 "../src/sudoku-window.vala"
	sudoku_game_start_clock (game);
#line 169 "../src/sudoku-window.vala"
	_tmp4_ = self->priv->_view;
#line 169 "../src/sudoku-window.vala"
	if (_tmp4_ != NULL) {
#line 713 "sudoku-window.c"
		GtkBox* _tmp5_;
		SudokuView* _tmp6_;
#line 170 "../src/sudoku-window.vala"
		_tmp5_ = self->priv->game_box;
#line 170 "../src/sudoku-window.vala"
		_tmp6_ = self->priv->_view;
#line 170 "../src/sudoku-window.vala"
		gtk_box_remove (_tmp5_, (GtkWidget*) _tmp6_);
#line 722 "sudoku-window.c"
	}
#line 172 "../src/sudoku-window.vala"
	sudoku_window_show_game_view (self);
#line 174 "../src/sudoku-window.vala"
	_tmp7_ = self->priv->settings;
#line 174 "../src/sudoku-window.vala"
	_tmp8_ = sudoku_view_new (game, _tmp7_);
#line 174 "../src/sudoku-window.vala"
	g_object_ref_sink (_tmp8_);
#line 174 "../src/sudoku-window.vala"
	_tmp9_ = _tmp8_;
#line 174 "../src/sudoku-window.vala"
	sudoku_window_set_view (self, _tmp9_);
#line 174 "../src/sudoku-window.vala"
	_g_object_unref0 (_tmp9_);
#line 176 "../src/sudoku-window.vala"
	_tmp10_ = self->priv->_view;
#line 176 "../src/sudoku-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp10_);
#line 177 "../src/sudoku-window.vala"
	_tmp11_ = self->priv->game_box;
#line 177 "../src/sudoku-window.vala"
	_tmp12_ = self->priv->_view;
#line 177 "../src/sudoku-window.vala"
	gtk_box_prepend (_tmp11_, (GtkWidget*) _tmp12_);
#line 178 "../src/sudoku-window.vala"
	_tmp13_ = self->priv->_view;
#line 178 "../src/sudoku-window.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp13_);
#line 180 "../src/sudoku-window.vala"
	_tmp14_ = self->priv->back_button;
#line 180 "../src/sudoku-window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, TRUE);
#line 756 "sudoku-window.c"
}

void
sudoku_window_show_new_game_screen (SudokuWindow* self)
{
	AdwWindowTitle* _tmp0_;
	GtkButton* _tmp1_;
	SudokuGame* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkLabel* _tmp5_;
	GtkImage* _tmp6_;
	GtkButton* _tmp7_;
#line 183 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 185 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->windowtitle;
#line 185 "../src/sudoku-window.vala"
	adw_window_title_set_title (_tmp0_, _ ("Select Difficulty"));
#line 186 "../src/sudoku-window.vala"
	sudoku_window_set_board_visible (self, FALSE);
#line 187 "../src/sudoku-window.vala"
	_tmp1_ = self->priv->back_button;
#line 187 "../src/sudoku-window.vala"
	_tmp2_ = self->priv->game;
#line 187 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, _tmp2_ != NULL);
#line 188 "../src/sudoku-window.vala"
	_tmp3_ = self->priv->undo_button;
#line 188 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
#line 189 "../src/sudoku-window.vala"
	_tmp4_ = self->priv->redo_button;
#line 189 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
#line 190 "../src/sudoku-window.vala"
	_tmp5_ = self->priv->clock_label;
#line 190 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
#line 191 "../src/sudoku-window.vala"
	_tmp6_ = self->priv->clock_image;
#line 191 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, FALSE);
#line 192 "../src/sudoku-window.vala"
	_tmp7_ = self->priv->start_button;
#line 192 "../src/sudoku-window.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp7_);
#line 804 "sudoku-window.c"
}

void
sudoku_window_activate_difficulty_checkbutton (SudokuWindow* self,
                                               DifficultyCategory difficulty)
{
#line 195 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 197 "../src/sudoku-window.vala"
	switch (difficulty) {
#line 197 "../src/sudoku-window.vala"
		case DIFFICULTY_CATEGORY_EASY:
#line 817 "sudoku-window.c"
		{
			GtkCheckButton* _tmp0_;
#line 200 "../src/sudoku-window.vala"
			_tmp0_ = self->priv->easy_check;
#line 200 "../src/sudoku-window.vala"
			g_signal_emit_by_name (_tmp0_, "activate");
#line 201 "../src/sudoku-window.vala"
			return;
#line 826 "sudoku-window.c"
		}
#line 197 "../src/sudoku-window.vala"
		case DIFFICULTY_CATEGORY_MEDIUM:
#line 830 "sudoku-window.c"
		{
			GtkCheckButton* _tmp1_;
#line 203 "../src/sudoku-window.vala"
			_tmp1_ = self->priv->medium_check;
#line 203 "../src/sudoku-window.vala"
			g_signal_emit_by_name (_tmp1_, "activate");
#line 204 "../src/sudoku-window.vala"
			return;
#line 839 "sudoku-window.c"
		}
#line 197 "../src/sudoku-window.vala"
		case DIFFICULTY_CATEGORY_HARD:
#line 843 "sudoku-window.c"
		{
			GtkCheckButton* _tmp2_;
#line 206 "../src/sudoku-window.vala"
			_tmp2_ = self->priv->hard_check;
#line 206 "../src/sudoku-window.vala"
			g_signal_emit_by_name (_tmp2_, "activate");
#line 207 "../src/sudoku-window.vala"
			return;
#line 852 "sudoku-window.c"
		}
#line 197 "../src/sudoku-window.vala"
		case DIFFICULTY_CATEGORY_VERY_HARD:
#line 856 "sudoku-window.c"
		{
			GtkCheckButton* _tmp3_;
#line 209 "../src/sudoku-window.vala"
			_tmp3_ = self->priv->very_hard_check;
#line 209 "../src/sudoku-window.vala"
			g_signal_emit_by_name (_tmp3_, "activate");
#line 210 "../src/sudoku-window.vala"
			return;
#line 865 "sudoku-window.c"
		}
		default:
		{
#line 212 "../src/sudoku-window.vala"
			g_assert_not_reached ();
#line 871 "sudoku-window.c"
		}
	}
}

void
sudoku_window_set_board_visible (SudokuWindow* self,
                                 gboolean visible)
{
	GtkBox* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GtkButton* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	GtkBox* _tmp14_;
#line 216 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 218 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->start_box;
#line 218 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, !visible);
#line 219 "../src/sudoku-window.vala"
	if (visible) {
#line 894 "sudoku-window.c"
		SudokuGame* _tmp2_;
		GameMode _tmp3_;
		GameMode _tmp4_;
#line 219 "../src/sudoku-window.vala"
		_tmp2_ = self->priv->game;
#line 219 "../src/sudoku-window.vala"
		_tmp3_ = sudoku_game_get_mode (_tmp2_);
#line 219 "../src/sudoku-window.vala"
		_tmp4_ = _tmp3_;
#line 219 "../src/sudoku-window.vala"
		_tmp1_ = _tmp4_ == GAME_MODE_CREATE;
#line 906 "sudoku-window.c"
	} else {
#line 219 "../src/sudoku-window.vala"
		_tmp1_ = FALSE;
#line 910 "sudoku-window.c"
	}
#line 219 "../src/sudoku-window.vala"
	_tmp5_ = self->priv->play_custom_game_button;
#line 219 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, _tmp1_);
#line 220 "../src/sudoku-window.vala"
	if (visible) {
#line 918 "sudoku-window.c"
		SudokuGame* _tmp8_;
		GameMode _tmp9_;
		GameMode _tmp10_;
#line 220 "../src/sudoku-window.vala"
		_tmp8_ = self->priv->game;
#line 220 "../src/sudoku-window.vala"
		_tmp9_ = sudoku_game_get_mode (_tmp8_);
#line 220 "../src/sudoku-window.vala"
		_tmp10_ = _tmp9_;
#line 220 "../src/sudoku-window.vala"
		_tmp7_ = _tmp10_ != GAME_MODE_CREATE;
#line 930 "sudoku-window.c"
	} else {
#line 220 "../src/sudoku-window.vala"
		_tmp7_ = FALSE;
#line 934 "sudoku-window.c"
	}
#line 220 "../src/sudoku-window.vala"
	if (_tmp7_) {
#line 938 "sudoku-window.c"
		gboolean _tmp11_;
		gboolean _tmp12_;
#line 220 "../src/sudoku-window.vala"
		_tmp11_ = sudoku_window_get_show_timer (self);
#line 220 "../src/sudoku-window.vala"
		_tmp12_ = _tmp11_;
#line 220 "../src/sudoku-window.vala"
		_tmp6_ = _tmp12_;
#line 947 "sudoku-window.c"
	} else {
#line 220 "../src/sudoku-window.vala"
		_tmp6_ = FALSE;
#line 951 "sudoku-window.c"
	}
#line 220 "../src/sudoku-window.vala"
	if (_tmp6_) {
#line 221 "../src/sudoku-window.vala"
		sudoku_window_display_pause_button (self);
#line 957 "sudoku-window.c"
	} else {
		GtkButton* _tmp13_;
#line 223 "../src/sudoku-window.vala"
		_tmp13_ = self->priv->play_pause_button;
#line 223 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp13_, FALSE);
#line 964 "sudoku-window.c"
	}
#line 224 "../src/sudoku-window.vala"
	_tmp14_ = self->priv->game_box;
#line 224 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp14_, visible);
#line 970 "sudoku-window.c"
}

gboolean
sudoku_window_is_board_visible (SudokuWindow* self)
{
	GtkBox* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 227 "../src/sudoku-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 229 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->game_box;
#line 229 "../src/sudoku-window.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 229 "../src/sudoku-window.vala"
	_tmp2_ = _tmp1_;
#line 229 "../src/sudoku-window.vala"
	result = _tmp2_;
#line 229 "../src/sudoku-window.vala"
	return result;
#line 992 "sudoku-window.c"
}

void
sudoku_window_show_game_view (SudokuWindow* self)
{
	SudokuGame* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	SudokuGame* _tmp4_;
	GameMode _tmp5_;
	GameMode _tmp6_;
#line 232 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 232 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->game;
#line 232 "../src/sudoku-window.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "game != null");
#line 235 "../src/sudoku-window.vala"
	sudoku_window_set_board_visible (self, TRUE);
#line 236 "../src/sudoku-window.vala"
	_tmp1_ = self->priv->back_button;
#line 236 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
#line 237 "../src/sudoku-window.vala"
	_tmp2_ = self->priv->undo_button;
#line 237 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
#line 238 "../src/sudoku-window.vala"
	_tmp3_ = self->priv->redo_button;
#line 238 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, TRUE);
#line 240 "../src/sudoku-window.vala"
	_tmp4_ = self->priv->game;
#line 240 "../src/sudoku-window.vala"
	_tmp5_ = sudoku_game_get_mode (_tmp4_);
#line 240 "../src/sudoku-window.vala"
	_tmp6_ = _tmp5_;
#line 240 "../src/sudoku-window.vala"
	if (_tmp6_ == GAME_MODE_PLAY) {
#line 1033 "sudoku-window.c"
		GtkButton* _tmp7_;
		GtkButton* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
		GtkLabel* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
		GtkImage* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
#line 242 "../src/sudoku-window.vala"
		_tmp7_ = self->priv->play_custom_game_button;
#line 242 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
#line 243 "../src/sudoku-window.vala"
		_tmp8_ = self->priv->play_pause_button;
#line 243 "../src/sudoku-window.vala"
		_tmp9_ = sudoku_window_get_show_timer (self);
#line 243 "../src/sudoku-window.vala"
		_tmp10_ = _tmp9_;
#line 243 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, _tmp10_);
#line 244 "../src/sudoku-window.vala"
		_tmp11_ = self->priv->clock_label;
#line 244 "../src/sudoku-window.vala"
		_tmp12_ = sudoku_window_get_show_timer (self);
#line 244 "../src/sudoku-window.vala"
		_tmp13_ = _tmp12_;
#line 244 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp11_, _tmp13_);
#line 245 "../src/sudoku-window.vala"
		_tmp14_ = self->priv->clock_image;
#line 245 "../src/sudoku-window.vala"
		_tmp15_ = sudoku_window_get_show_timer (self);
#line 245 "../src/sudoku-window.vala"
		_tmp16_ = _tmp15_;
#line 245 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp14_, _tmp16_);
#line 1072 "sudoku-window.c"
	} else {
		GtkLabel* _tmp17_;
		GtkImage* _tmp18_;
		GtkButton* _tmp19_;
		GtkButton* _tmp20_;
#line 249 "../src/sudoku-window.vala"
		_tmp17_ = self->priv->clock_label;
#line 249 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp17_, FALSE);
#line 250 "../src/sudoku-window.vala"
		_tmp18_ = self->priv->clock_image;
#line 250 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp18_, FALSE);
#line 251 "../src/sudoku-window.vala"
		_tmp19_ = self->priv->play_custom_game_button;
#line 251 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp19_, TRUE);
#line 252 "../src/sudoku-window.vala"
		_tmp20_ = self->priv->play_pause_button;
#line 252 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp20_, FALSE);
#line 1094 "sudoku-window.c"
	}
#line 255 "../src/sudoku-window.vala"
	sudoku_window_set_headerbar_title (self);
#line 1098 "sudoku-window.c"
}

void
sudoku_window_board_completed (SudokuWindow* self)
{
	GtkButton* _tmp0_;
#line 258 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 260 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->play_custom_game_button;
#line 260 "../src/sudoku-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
#line 1111 "sudoku-window.c"
}

void
sudoku_window_set_headerbar_title (SudokuWindow* self)
{
	SudokuGame* _tmp0_;
	SudokuGame* _tmp1_;
	GameMode _tmp2_;
	GameMode _tmp3_;
#line 263 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->game;
#line 263 "../src/sudoku-window.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "game != null");
#line 266 "../src/sudoku-window.vala"
	_tmp1_ = self->priv->game;
#line 266 "../src/sudoku-window.vala"
	_tmp2_ = sudoku_game_get_mode (_tmp1_);
#line 266 "../src/sudoku-window.vala"
	_tmp3_ = _tmp2_;
#line 266 "../src/sudoku-window.vala"
	if (_tmp3_ == GAME_MODE_PLAY) {
#line 1135 "sudoku-window.c"
		AdwWindowTitle* _tmp4_;
#line 267 "../src/sudoku-window.vala"
		_tmp4_ = self->priv->windowtitle;
#line 267 "../src/sudoku-window.vala"
		adw_window_title_set_title (_tmp4_, _ ("Sudoku"));
#line 1141 "sudoku-window.c"
	} else {
		AdwWindowTitle* _tmp5_;
#line 269 "../src/sudoku-window.vala"
		_tmp5_ = self->priv->windowtitle;
#line 269 "../src/sudoku-window.vala"
		adw_window_title_set_title (_tmp5_, _ ("Create Puzzle"));
#line 1148 "sudoku-window.c"
	}
}

void
sudoku_window_display_pause_button (SudokuWindow* self)
{
	GtkButton* _tmp0_;
	const gchar* _tmp1_ = NULL;
	SudokuGame* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkButton* _tmp5_;
	const gchar* _tmp6_ = NULL;
	SudokuGame* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GtkButton* _tmp10_;
#line 272 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 274 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->play_pause_button;
#line 274 "../src/sudoku-window.vala"
	gtk_widget_show ((GtkWidget*) _tmp0_);
#line 275 "../src/sudoku-window.vala"
	_tmp2_ = self->priv->game;
#line 275 "../src/sudoku-window.vala"
	_tmp3_ = sudoku_game_get_paused (_tmp2_);
#line 275 "../src/sudoku-window.vala"
	_tmp4_ = _tmp3_;
#line 275 "../src/sudoku-window.vala"
	if (_tmp4_) {
#line 275 "../src/sudoku-window.vala"
		_tmp1_ = "media-playback-start-symbolic";
#line 1182 "sudoku-window.c"
	} else {
#line 275 "../src/sudoku-window.vala"
		_tmp1_ = "media-playback-pause-symbolic";
#line 1186 "sudoku-window.c"
	}
#line 275 "../src/sudoku-window.vala"
	_tmp5_ = self->priv->play_pause_button;
#line 275 "../src/sudoku-window.vala"
	gtk_button_set_icon_name (_tmp5_, _tmp1_);
#line 276 "../src/sudoku-window.vala"
	_tmp7_ = self->priv->game;
#line 276 "../src/sudoku-window.vala"
	_tmp8_ = sudoku_game_get_paused (_tmp7_);
#line 276 "../src/sudoku-window.vala"
	_tmp9_ = _tmp8_;
#line 276 "../src/sudoku-window.vala"
	if (_tmp9_) {
#line 276 "../src/sudoku-window.vala"
		_tmp6_ = _ ("Play");
#line 1202 "sudoku-window.c"
	} else {
#line 276 "../src/sudoku-window.vala"
		_tmp6_ = _ ("Pause");
#line 1206 "sudoku-window.c"
	}
#line 276 "../src/sudoku-window.vala"
	_tmp10_ = self->priv->play_pause_button;
#line 276 "../src/sudoku-window.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp10_, _tmp6_);
#line 1212 "sudoku-window.c"
}

static void
sudoku_window_tick_cb (SudokuWindow* self)
{
	gint elapsed_time = 0;
	SudokuGame* _tmp0_;
	gint hours = 0;
	gint minutes = 0;
	gint seconds = 0;
#line 279 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 281 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->game;
#line 281 "../src/sudoku-window.vala"
	elapsed_time = (gint) sudoku_game_get_total_time_played (_tmp0_);
#line 282 "../src/sudoku-window.vala"
	hours = elapsed_time / 3600;
#line 283 "../src/sudoku-window.vala"
	minutes = (elapsed_time - (hours * 3600)) / 60;
#line 284 "../src/sudoku-window.vala"
	seconds = (elapsed_time - (hours * 3600)) - (minutes * 60);
#line 285 "../src/sudoku-window.vala"
	if (hours > 0) {
#line 1237 "sudoku-window.c"
		GtkLabel* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 286 "../src/sudoku-window.vala"
		_tmp1_ = self->priv->clock_label;
#line 286 "../src/sudoku-window.vala"
		_tmp2_ = g_strdup_printf ("%02d∶\xE2\x80\x8E%02d∶\xE2\x80\x8E%02d", hours, minutes, seconds);
#line 286 "../src/sudoku-window.vala"
		_tmp3_ = _tmp2_;
#line 286 "../src/sudoku-window.vala"
		gtk_label_set_text (_tmp1_, _tmp3_);
#line 286 "../src/sudoku-window.vala"
		_g_free0 (_tmp3_);
#line 1251 "sudoku-window.c"
	} else {
		GtkLabel* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 288 "../src/sudoku-window.vala"
		_tmp4_ = self->priv->clock_label;
#line 288 "../src/sudoku-window.vala"
		_tmp5_ = g_strdup_printf ("%02d∶\xE2\x80\x8E%02d", minutes, seconds);
#line 288 "../src/sudoku-window.vala"
		_tmp6_ = _tmp5_;
#line 288 "../src/sudoku-window.vala"
		gtk_label_set_text (_tmp4_, _tmp6_);
#line 288 "../src/sudoku-window.vala"
		_g_free0 (_tmp6_);
#line 1266 "sudoku-window.c"
	}
}

static void
sudoku_window_set_clock_placed_in_headerbar (SudokuWindow* self,
                                             gboolean value)
{
#line 291 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 293 "../src/sudoku-window.vala"
	if (value == self->priv->clock_in_headerbar) {
#line 294 "../src/sudoku-window.vala"
		return;
#line 1280 "sudoku-window.c"
	}
#line 296 "../src/sudoku-window.vala"
	self->priv->clock_in_headerbar = value;
#line 297 "../src/sudoku-window.vala"
	if (value) {
#line 1286 "sudoku-window.c"
		GtkBox* _tmp0_;
		GtkBox* _tmp1_;
		AdwHeaderBar* _tmp2_;
		GtkBox* _tmp3_;
#line 299 "../src/sudoku-window.vala"
		_tmp0_ = self->priv->game_box;
#line 299 "../src/sudoku-window.vala"
		_tmp1_ = self->priv->clock_box;
#line 299 "../src/sudoku-window.vala"
		gtk_box_remove (_tmp0_, (GtkWidget*) _tmp1_);
#line 300 "../src/sudoku-window.vala"
		_tmp2_ = self->priv->headerbar;
#line 300 "../src/sudoku-window.vala"
		_tmp3_ = self->priv->clock_box;
#line 300 "../src/sudoku-window.vala"
		adw_header_bar_pack_end (_tmp2_, (GtkWidget*) _tmp3_);
#line 1303 "sudoku-window.c"
	} else {
		AdwHeaderBar* _tmp4_;
		GtkBox* _tmp5_;
		GtkBox* _tmp6_;
		GtkBox* _tmp7_;
#line 304 "../src/sudoku-window.vala"
		_tmp4_ = self->priv->headerbar;
#line 304 "../src/sudoku-window.vala"
		_tmp5_ = self->priv->clock_box;
#line 304 "../src/sudoku-window.vala"
		adw_header_bar_remove (_tmp4_, (GtkWidget*) _tmp5_);
#line 305 "../src/sudoku-window.vala"
		_tmp6_ = self->priv->game_box;
#line 305 "../src/sudoku-window.vala"
		_tmp7_ = self->priv->clock_box;
#line 305 "../src/sudoku-window.vala"
		gtk_box_append (_tmp6_, (GtkWidget*) _tmp7_);
#line 1321 "sudoku-window.c"
	}
}

static void
sudoku_window_button_released_cb (SudokuWindow* self,
                                  GtkGestureClick* gesture,
                                  gint n_press,
                                  gdouble x,
                                  gdouble y)
{
	gboolean _tmp0_ = FALSE;
	SudokuView* _tmp1_ = NULL;
	SudokuView* _tmp2_;
#line 309 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 309 "../src/sudoku-window.vala"
	g_return_if_fail (gesture != NULL);
#line 314 "../src/sudoku-window.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_PRIMARY)) {
#line 315 "../src/sudoku-window.vala"
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_SECONDARY);
#line 1343 "sudoku-window.c"
	} else {
#line 314 "../src/sudoku-window.vala"
		_tmp0_ = FALSE;
#line 1347 "sudoku-window.c"
	}
#line 314 "../src/sudoku-window.vala"
	if (_tmp0_) {
#line 316 "../src/sudoku-window.vala"
		return;
#line 1353 "sudoku-window.c"
	}
#line 318 "../src/sudoku-window.vala"
	_tmp2_ = self->priv->_view;
#line 318 "../src/sudoku-window.vala"
	_tmp1_ = _tmp2_;
#line 318 "../src/sudoku-window.vala"
	if (_tmp1_ != NULL) {
#line 318 "../src/sudoku-window.vala"
		sudoku_view_dismiss_popovers (_tmp1_);
#line 1363 "sudoku-window.c"
	}
#line 319 "../src/sudoku-window.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 1367 "sudoku-window.c"
}

static void
sudoku_window_long_press_cb (SudokuWindow* self,
                             GtkGestureLongPress* gesture,
                             gdouble x,
                             gdouble y)
{
#line 322 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 322 "../src/sudoku-window.vala"
	g_return_if_fail (gesture != NULL);
#line 326 "../src/sudoku-window.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 1382 "sudoku-window.c"
}

SudokuView*
sudoku_window_get_view (SudokuWindow* self)
{
	SudokuView* result;
	SudokuView* _tmp0_;
#line 61 "../src/sudoku-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->_view;
#line 61 "../src/sudoku-window.vala"
	result = _tmp0_;
#line 61 "../src/sudoku-window.vala"
	return result;
#line 1398 "sudoku-window.c"
}

static void
sudoku_window_set_view (SudokuWindow* self,
                        SudokuView* value)
{
	SudokuView* old_value;
#line 61 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/sudoku-window.vala"
	old_value = sudoku_window_get_view (self);
#line 61 "../src/sudoku-window.vala"
	if (old_value != value) {
#line 1412 "sudoku-window.c"
		SudokuView* _tmp0_;
#line 61 "../src/sudoku-window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 61 "../src/sudoku-window.vala"
		_g_object_unref0 (self->priv->_view);
#line 61 "../src/sudoku-window.vala"
		self->priv->_view = _tmp0_;
#line 61 "../src/sudoku-window.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_VIEW_PROPERTY]);
#line 1422 "sudoku-window.c"
	}
}

gboolean
sudoku_window_get_show_timer (SudokuWindow* self)
{
	gboolean result;
#line 140 "../src/sudoku-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 140 "../src/sudoku-window.vala"
	result = self->priv->_show_timer;
#line 140 "../src/sudoku-window.vala"
	return result;
#line 1436 "sudoku-window.c"
}

void
sudoku_window_set_show_timer (SudokuWindow* self,
                              gboolean value)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
#line 141 "../src/sudoku-window.vala"
	g_return_if_fail (self != NULL);
#line 143 "../src/sudoku-window.vala"
	self->priv->_show_timer = value;
#line 144 "../src/sudoku-window.vala"
	_tmp1_ = self->priv->game;
#line 144 "../src/sudoku-window.vala"
	if (_tmp1_ != NULL) {
#line 1453 "sudoku-window.c"
		SudokuGame* _tmp2_;
		GameMode _tmp3_;
		GameMode _tmp4_;
#line 144 "../src/sudoku-window.vala"
		_tmp2_ = self->priv->game;
#line 144 "../src/sudoku-window.vala"
		_tmp3_ = sudoku_game_get_mode (_tmp2_);
#line 144 "../src/sudoku-window.vala"
		_tmp4_ = _tmp3_;
#line 144 "../src/sudoku-window.vala"
		_tmp0_ = _tmp4_ != GAME_MODE_CREATE;
#line 1465 "sudoku-window.c"
	} else {
#line 144 "../src/sudoku-window.vala"
		_tmp0_ = FALSE;
#line 1469 "sudoku-window.c"
	}
#line 144 "../src/sudoku-window.vala"
	if (_tmp0_) {
#line 1473 "sudoku-window.c"
		GtkLabel* _tmp5_;
		GtkImage* _tmp6_;
#line 146 "../src/sudoku-window.vala"
		_tmp5_ = self->priv->clock_label;
#line 146 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, value);
#line 147 "../src/sudoku-window.vala"
		_tmp6_ = self->priv->clock_image;
#line 147 "../src/sudoku-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp6_, value);
#line 148 "../src/sudoku-window.vala"
		if (value) {
#line 149 "../src/sudoku-window.vala"
			sudoku_window_display_pause_button (self);
#line 1488 "sudoku-window.c"
		} else {
			GtkButton* _tmp7_;
#line 151 "../src/sudoku-window.vala"
			_tmp7_ = self->priv->play_pause_button;
#line 151 "../src/sudoku-window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
#line 1495 "sudoku-window.c"
		}
	}
#line 141 "../src/sudoku-window.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_SHOW_TIMER_PROPERTY]);
#line 1500 "sudoku-window.c"
}

static void
sudoku_window_class_init (SudokuWindowClass * klass,
                          gpointer klass_data)
{
#line 26 "../src/sudoku-window.vala"
	sudoku_window_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/sudoku-window.vala"
	g_type_class_adjust_private_offset (klass, &SudokuWindow_private_offset);
#line 26 "../src/sudoku-window.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) sudoku_window_real_size_allocate;
#line 26 "../src/sudoku-window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_window_get_property;
#line 26 "../src/sudoku-window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_window_set_property;
#line 26 "../src/sudoku-window.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_window_finalize;
#line 26 "../src/sudoku-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_VIEW_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", TYPE_SUDOKU_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_SHOW_TIMER_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_SHOW_TIMER_PROPERTY] = g_param_spec_boolean ("show-timer", "show-timer", "show-timer", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Sudoku/ui/sudoku-window.ui");
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "headerbar", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, headerbar));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "windowtitle", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, windowtitle));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "start_box", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, start_box));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "start_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, start_button));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "easy_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, easy_check));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "medium_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, medium_check));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "hard_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, hard_check));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "very_hard_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, very_hard_check));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "game_box", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, game_box));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_menu", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, main_menu));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "undo_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, undo_button));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "redo_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, redo_button));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "back_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, back_button));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clock_box", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, clock_box));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clock_label", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, clock_label));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clock_image", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, clock_image));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "play_custom_game_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, play_custom_game_button));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "play_pause_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, play_pause_button));
#line 26 "../src/sudoku-window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "start_game_cb", G_CALLBACK(_sudoku_window_start_game_cb_gtk_button_clicked));
#line 1563 "sudoku-window.c"
}

static void
sudoku_window_instance_init (SudokuWindow * self,
                             gpointer klass)
{
	GtkGestureClick* _tmp0_;
	GtkGestureLongPress* _tmp1_;
#line 26 "../src/sudoku-window.vala"
	self->priv = sudoku_window_get_instance_private (self);
#line 63 "../src/sudoku-window.vala"
	self->priv->game = NULL;
#line 68 "../src/sudoku-window.vala"
	_tmp0_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 68 "../src/sudoku-window.vala"
	self->priv->button_controller = _tmp0_;
#line 69 "../src/sudoku-window.vala"
	_tmp1_ = (GtkGestureLongPress*) gtk_gesture_long_press_new ();
#line 69 "../src/sudoku-window.vala"
	self->priv->long_press_controller = _tmp1_;
#line 138 "../src/sudoku-window.vala"
	self->priv->_show_timer = TRUE;
#line 26 "../src/sudoku-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1588 "sudoku-window.c"
}

static void
sudoku_window_finalize (GObject * obj)
{
	SudokuWindow * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	GSettings* _tmp8_;
#line 26 "../src/sudoku-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_WINDOW, SudokuWindow);
#line 104 "../src/sudoku-window.vala"
	_tmp0_ = self->priv->settings;
#line 104 "../src/sudoku-window.vala"
	g_settings_delay (_tmp0_);
#line 105 "../src/sudoku-window.vala"
	_tmp1_ = self->priv->settings;
#line 105 "../src/sudoku-window.vala"
	g_settings_set_int (_tmp1_, "window-width", self->priv->window_width);
#line 106 "../src/sudoku-window.vala"
	_tmp2_ = self->priv->settings;
#line 106 "../src/sudoku-window.vala"
	g_settings_set_int (_tmp2_, "window-height", self->priv->window_height);
#line 107 "../src/sudoku-window.vala"
	if (self->priv->window_is_maximized) {
#line 107 "../src/sudoku-window.vala"
		_tmp3_ = TRUE;
#line 1622 "sudoku-window.c"
	} else {
#line 107 "../src/sudoku-window.vala"
		_tmp3_ = self->priv->window_is_fullscreen;
#line 1626 "sudoku-window.c"
	}
#line 107 "../src/sudoku-window.vala"
	_tmp4_ = self->priv->settings;
#line 107 "../src/sudoku-window.vala"
	g_settings_set_boolean (_tmp4_, "window-is-maximized", _tmp3_);
#line 108 "../src/sudoku-window.vala"
	_tmp5_ = self->priv->settings;
#line 108 "../src/sudoku-window.vala"
	_tmp6_ = sudoku_window_get_show_timer (self);
#line 108 "../src/sudoku-window.vala"
	_tmp7_ = _tmp6_;
#line 108 "../src/sudoku-window.vala"
	g_settings_set_boolean (_tmp5_, "show-timer", _tmp7_);
#line 109 "../src/sudoku-window.vala"
	_tmp8_ = self->priv->settings;
#line 109 "../src/sudoku-window.vala"
	g_settings_apply (_tmp8_);
#line 59 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->settings);
#line 61 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->_view);
#line 63 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->game);
#line 68 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 69 "../src/sudoku-window.vala"
	_g_object_unref0 (self->priv->long_press_controller);
#line 26 "../src/sudoku-window.vala"
	G_OBJECT_CLASS (sudoku_window_parent_class)->finalize (obj);
#line 1656 "sudoku-window.c"
}

static GType
sudoku_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuWindow), 0, (GInstanceInitFunc) sudoku_window_instance_init, NULL };
	GType sudoku_window_type_id;
	sudoku_window_type_id = g_type_register_static (adw_application_window_get_type (), "SudokuWindow", &g_define_type_info, 0);
	SudokuWindow_private_offset = g_type_add_instance_private (sudoku_window_type_id, sizeof (SudokuWindowPrivate));
	return sudoku_window_type_id;
}

GType
sudoku_window_get_type (void)
{
	static volatile gsize sudoku_window_type_id__once = 0;
	if (g_once_init_enter (&sudoku_window_type_id__once)) {
		GType sudoku_window_type_id;
		sudoku_window_type_id = sudoku_window_get_type_once ();
		g_once_init_leave (&sudoku_window_type_id__once, sudoku_window_type_id);
	}
	return sudoku_window_type_id__once;
}

static void
_vala_sudoku_window_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	SudokuWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_WINDOW, SudokuWindow);
#line 26 "../src/sudoku-window.vala"
	switch (property_id) {
#line 26 "../src/sudoku-window.vala"
		case SUDOKU_WINDOW_VIEW_PROPERTY:
#line 26 "../src/sudoku-window.vala"
		g_value_set_object (value, sudoku_window_get_view (self));
#line 26 "../src/sudoku-window.vala"
		break;
#line 26 "../src/sudoku-window.vala"
		case SUDOKU_WINDOW_SHOW_TIMER_PROPERTY:
#line 26 "../src/sudoku-window.vala"
		g_value_set_boolean (value, sudoku_window_get_show_timer (self));
#line 26 "../src/sudoku-window.vala"
		break;
#line 1703 "sudoku-window.c"
		default:
#line 26 "../src/sudoku-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-window.vala"
		break;
#line 1709 "sudoku-window.c"
	}
}

static void
_vala_sudoku_window_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	SudokuWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_WINDOW, SudokuWindow);
#line 26 "../src/sudoku-window.vala"
	switch (property_id) {
#line 26 "../src/sudoku-window.vala"
		case SUDOKU_WINDOW_VIEW_PROPERTY:
#line 26 "../src/sudoku-window.vala"
		sudoku_window_set_view (self, g_value_get_object (value));
#line 26 "../src/sudoku-window.vala"
		break;
#line 26 "../src/sudoku-window.vala"
		case SUDOKU_WINDOW_SHOW_TIMER_PROPERTY:
#line 26 "../src/sudoku-window.vala"
		sudoku_window_set_show_timer (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-window.vala"
		break;
#line 1735 "sudoku-window.c"
		default:
#line 26 "../src/sudoku-window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-window.vala"
		break;
#line 1741 "sudoku-window.c"
	}
}

